// JavaScript Document
function Cgame(gameDivId){
	var game=this;
	this.gameDiv=document.getElementById(gameDivId);
	this.gameDiv.style.direction='ltr'
	this.clientWidth=this.clientHeight=0;
	this.homeURL=homeURL+'js/games/race/';
	this.time=0;this.frameTime=0;
	this.UI=false;//UI object
	this.SFX=false;//carSFX object
	this.assets=false;//assets object
	
	this.status=false;//what page we're in (like main menu,playing, etc..)
	
	this.player=false;//current player
	this.loadingStage=0;//increases as different loading functions pass succsessfully
	this.config=false;//parsed config file
	
	this.gameType=false;//single or multi
	this.GSPMultiplayer=false;//connected with multiplayer api
	this.multiGameStarted=false;//multiplayer game started or nor
	this.trackElements=false;
	
	this.cars=false;//array of players in the current race
	this.trackPan=0;//camera position on the track
	this.trackPos=0;//track position - to make it move around all race
	this.endPos=0;//track position at the end of the race
	this.trackLength=0;//number of characters in the current race
	this.raceTime=0;//miliseconds in the current race
	this.typeTime=0;//last time the user typed
	this.difficulty=0;//0=easy 1=medium 2=hard 3=multiplayer
	this.sentence='';//current sentence
	this.sentences=null;//array with all the sentences in the current race
	this.currentLetter=0;//current letter index for the player (from 0 to the total number of characters in the race)
	this.finished=false;//wether the player completed the race
	this.DrawInterval=null;
	this.language;//the current language (ex.: 'en')
		var GET=getSearchParameters();
		var lang=GET.lang;if(!lang)lang=GET.language;if(!lang)lang=defaultLanguage;
		lang=lang.split("_");
		this.language=lang[0].toLowerCase();
	this.soundOn=true;//should we play sound effects ?
	
	this.hints=0;//hints used in the current race by the player
	this.hintStart=0;

	this.Load=Load;function Load(forceResize){
		if(this.DrawInterval)clearInterval(this.DrawInterval);
		this.DrawInterval=setInterval(RunMain,30);
		this.UI=new Cui(this);
		this.SFX=new CcarSFX(this);
		if(this.gameDiv){
			this.gameDiv.style.direction='ltr'
			cw=this.gameDiv.clientWidth;ch=this.gameDiv.clientHeight;
			if(cw/ch>960/640)cw=ch*960/640;else ch=cw*640/960;
			if(this.clientWidth!=cw || this.clientHeight!=ch || forceResize){
				this.Resize(cw,ch);
			}
			if(!this.gameDiv.style.background){this.gameDiv.style.background='#ffffff url("'+this.homeURL+'assets/images/bgSmall.jpg") no-repeat left top';this.gameDiv.style.backgroundSize=cw+'px '+ch+'px';};
		}

		this.assets=new resourcesManager(this);
		if(!configURLStart || configURLStart=='')configURLStart=this.homeURL+'config/config_';
		configURL=configURLStart+this.language+configURLEnd;
		if(configURL.indexOf('http://')<0)configURL=this.homeURL+configURL;
		this.assets.LoadFile('config',configURL);
		this.assets.LoadImage('LoadingBar',this.homeURL+'assets/images/Loading_bar1.png');
		this.assets.LoadImage('LoadingFrame',this.homeURL+'assets/images/Loading_fame.png');
		this.assets.Start(this.preStartLoad,this);
	}
	
	this.Resize=Resize;function Resize(Pwidth,Pheight){//960x640
		this.clientWidth=Pwidth;
		this.clientHeight=Pheight;
		this.gameDiv.style.backgroundSize=Pwidth+'px '+Pheight+'px';
		this.gameDiv.style.direction='ltr'
		var obj=document.getElementById('UIContainer');
		if(obj){
			obj.style.width=Pwidth+'px';
			obj.style.height=Pheight+'px';
		}
		var obj=document.getElementById('loadingContainer');
		if(obj){
			obj.style.width=Pwidth+'px';
			obj.style.height=Pheight+'px';
		}
		if(this.UI){
			this.UI.scaleVal=Pwidth/960;
			this.UI.status=false;
			this.UI.hidePopup();
			this.UI.drawLoading(true);
		}
	}
	
	this.preStartLoad=preStartLoad;function preStartLoad(){
		this.config=JSON.parse(this.assets.Data.Files.config);
		if(this.gspStartedON)this.startLoad();
		startGSP(0,this);
	}
	
	this.startLoad=startLoad;function startLoad(){
		if(this.loadingStage>=1)return;
		//preloading the font
		this.assets.LoadFile('font',this.homeURL+'assets/font/airstrikecond.ttf');
		//preloading button components
		//tab
		this.assets.LoadImage('middletab',this.homeURL+'assets/images/buttons/middletab.png');
		this.assets.LoadImage('middletabOn',this.homeURL+'assets/images/buttons/middletabOn.png');
		//65
		this.assets.LoadImage('middle65',this.homeURL+'assets/images/buttons/middle65.png');
		this.assets.LoadImage('middle65On',this.homeURL+'assets/images/buttons/middle65On.png');
		this.assets.LoadImage('margin65',this.homeURL+'assets/images/buttons/margin65.png');
		this.assets.LoadImage('margin65On',this.homeURL+'assets/images/buttons/margin65On.png');
		
		this.assets.LoadImage('margin65off',this.homeURL+'assets/images/buttons/margin65.png');
		//52
		this.assets.LoadImage('middle52',this.homeURL+'assets/images/buttons/middle52.png');
		this.assets.LoadImage('middle52On',this.homeURL+'assets/images/buttons/middle52On.png');
		this.assets.LoadImage('margin52',this.homeURL+'assets/images/buttons/margin52.png');
		this.assets.LoadImage('margin52On',this.homeURL+'assets/images/buttons/margin52On.png');
		//64
		this.assets.LoadImage('middle64',this.homeURL+'assets/images/buttons/middle64.png');
		this.assets.LoadImage('middle64On',this.homeURL+'assets/images/buttons/middle64On.png');
		this.assets.LoadImage('margin64',this.homeURL+'assets/images/buttons/margin64.png');
		this.assets.LoadImage('margin64On',this.homeURL+'assets/images/buttons/margin64On.png');
		this.assets.LoadImage('margin64disabled',this.homeURL+'assets/images/buttons/margin64On.png');
		
		
		this.assets.LoadFile('LevelConfig',this.homeURL+'config/levels.json');
		this.assets.LoadImage('LoginBackground',this.homeURL+'assets/images/translate/'+this.language+'/bg_02.png');
		this.assets.LoadImage('emptyBG',this.homeURL+'assets/images/bg_03.png');
		this.assets.LoadImage('highScoresHeading',this.homeURL+'assets/images/highScoresHeading.jpg');
		this.assets.LoadImage('highScoreButton',this.homeURL+'assets/images/highScore.png');
		this.assets.LoadImage('highScoreButtonOn',this.homeURL+'assets/images/highScoreOn.png');

		this.assets.LoadImage('flag',this.homeURL+'assets/images/translate/'+this.language+'/flag.png');
		this.assets.LoadImage('PopupBg',this.homeURL+'assets/images/popupBG.png');
		this.assets.LoadImage('LangPopup',this.homeURL+'assets/images/langPopup.png');
		this.assets.LoadImage('MainMenuBg',this.homeURL+'assets/images/MenuBG-59.png');
		this.assets.LoadImage('EmptyButton',this.homeURL+'assets/images/empty-off.png');
		this.assets.LoadImage('EmptyButtonH',this.homeURL+'assets/images/empty-on.png');
		this.assets.LoadImage('soundOFF',this.homeURL+'assets/images/soundOFF.png');
		this.assets.LoadImage('soundON',this.homeURL+'assets/images/soundON.png');
		this.assets.LoadImage('GarrageButton',this.homeURL+'assets/images/Garage_n.png');
		this.assets.LoadImage('GarrageButtonH',this.homeURL+'assets/images/Garage_a.png');
		this.assets.LoadImage('garrageButton',this.homeURL+'assets/images/Garage.png');
		this.assets.LoadImage('garrageButtonH',this.homeURL+'assets/images/GarageSEL.png');
		this.assets.LoadImage('soloButton',this.homeURL+'assets/images/solo.png');
		this.assets.LoadImage('soloButtonH',this.homeURL+'assets/images/SoloSEL.png');
		this.assets.LoadImage('multiButton',this.homeURL+'assets/images/Multi.png');
		this.assets.LoadImage('multiButtonH',this.homeURL+'assets/images/MultiSEL.png');
		this.assets.LoadImage('ActionBar',this.homeURL+'assets/images/Action_bar.png');
		this.assets.LoadImage('PlayerIcon',this.homeURL+'assets/images/PlayesIcon.png');
		this.assets.LoadImage('GamesIcon',this.homeURL+'assets/images/gamesIcon.png');
		

		if(GSP && this.GSPStart)providers=GSP.getSocialProviders();else providers=new Array();
		console.log(providers);
		for(i=0;i<providers.length;i++){
			console.log('loading '+providers[i]);
			this.assets.LoadImage(providers[i],this.homeURL+'assets/images/providers/'+providers[i]+'.png');
			this.assets.LoadImage(providers[i]+'H',this.homeURL+'assets/images/providers/'+providers[i]+'ON.png');
		}
		for(i=0;i<this.config.gameSettings.language.list.length;i++){
			this.assets.LoadImage('flag_'+i,this.homeURL+'assets/images/translate/'+this.config.gameSettings.language.list[i].folder+'/flag.png');
		}

		for(i=0;i<this.config.gameSettings.cars.length;i++){
			for(j=0;j<this.config.gameSettings.cars[i].images.length;j++){
				this.assets.LoadImage('carImg_'+i+'_'+j,this.homeURL+'assets/images/'+this.config.gameSettings.cars[i].images[j]);
			}
		}
		
		var skipAdd=getCookie('typingRaceSkipAdd');
		if(skipAdd=='' && this.config.gameSettings.settings.showAdd)requestAds();
		setCookie('typingRaceSkipAdd','',0);
		this.assets.Start(this.MainLoadComplete,this);
	}
	
	this.MainLoadComplete=MainLoadComplete;function MainLoadComplete(){
		this.assets.Data.Images['middle64R']=this.assets.Data.Images['middle64'];
		this.assets.Data.Images['middle64ROn']=this.assets.Data.Images['middle64On'];
		this.assets.Data.Images['margin64R']=this.assets.Data.Images['margin64'];
		this.assets.Data.Images['margin64ROn']=this.assets.Data.Images['margin64On'];

		this.loadingStage=1;
		this.status='main menu';
		if(this.UI){
			this.UI.status=false;
			this.UI.hidePopup();
			this.UI.drawLoading(true);
		}
	}
	
	this.LoadGameData=LoadGameData;function LoadGameData(){
		if(this.loadingStage>=2){
			this.LoadedGameData();
			return;
		}
		var i,j;
		
		this.assets.LoadImage('raceBG',this.homeURL+'assets/images/race/RaceBG.png');
		this.assets.LoadImage('bigToolTip',this.homeURL+'assets/images/race/bigToolTip.png');
		this.assets.LoadImage('Start',this.homeURL+'assets/images/race/Start.png');
		this.assets.LoadImage('Finish',this.homeURL+'assets/images/race/Finish.png');
		this.assets.LoadImage('RedLight',this.homeURL+'assets/images/race/redlight.png');
		this.assets.LoadImage('YellowLight',this.homeURL+'assets/images/race/yellowLight.png');
		this.assets.LoadImage('GreenLight',this.homeURL+'assets/images/race/greenlight.png');
		this.assets.LoadImage('TypingFrame',this.homeURL+'assets/images/race/Typing_Frame.png');
		this.assets.LoadImage('WPMclock',this.homeURL+'assets/images/race/WPNclock.png');
		this.assets.LoadImage('WPMdial',this.homeURL+'assets/images/race/WPNdial.png');
		this.assets.LoadImage('ErrorClock',this.homeURL+'assets/images/race/ErrorClock.png');
		this.assets.LoadImage('ErrorDial',this.homeURL+'assets/images/race/ErrorDial.png');
		this.assets.LoadImage('ACC',this.homeURL+'assets/images/race/ACC.png');
		this.assets.LoadImage('Time',this.homeURL+'assets/images/race/Time.png');
		this.assets.LoadImage('HintBG',this.homeURL+'assets/images/race/hintLeftBG.png');
		this.assets.LoadImage('hintIcon',this.homeURL+'assets/images/race/hintLeftIcon.png');
		this.assets.LoadImage('replay',this.homeURL+'assets/images/race/replay.png');
		this.assets.LoadImage('hintButton',this.homeURL+'assets/images/race/HintBTN-BG.png');


		this.assets.LoadImage('smoke_1_1',this.homeURL+'assets/images/sfx/CarSmoke_01_1.png');
		this.assets.LoadImage('smoke_1_2',this.homeURL+'assets/images/sfx/CarSmoke_01_2.png');
		this.assets.LoadImage('smoke_1_3',this.homeURL+'assets/images/sfx/CarSmoke_01_3.png');
		this.assets.LoadImage('smoke_1_4',this.homeURL+'assets/images/sfx/CarSmoke_01_4.png');
		this.assets.LoadImage('smoke_2_1',this.homeURL+'assets/images/sfx/CarSmoke_02_1.png');
		this.assets.LoadImage('smoke_2_2',this.homeURL+'assets/images/sfx/CarSmoke_02_2.png');
		this.assets.LoadImage('smoke_2_3',this.homeURL+'assets/images/sfx/CarSmoke_02_3.png');
		this.assets.LoadImage('smoke_2_4',this.homeURL+'assets/images/sfx/CarSmoke_02_4.png');
		this.assets.LoadImage('smoke_2_5',this.homeURL+'assets/images/sfx/CarSmoke_02_5.png');
		this.assets.LoadImage('smoke_2_6',this.homeURL+'assets/images/sfx/CarSmoke_02_6.png');
		this.assets.LoadImage('fire_1_1',this.homeURL+'assets/images/sfx/fire_01_1.png');
		this.assets.LoadImage('fire_1_2',this.homeURL+'assets/images/sfx/fire_01_2.png');
		this.assets.LoadImage('fire_1_3',this.homeURL+'assets/images/sfx/fire_01_3.png');
		this.assets.LoadImage('fire_1_4',this.homeURL+'assets/images/sfx/fire_01_4.png');
		this.assets.LoadImage('fire_2_1',this.homeURL+'assets/images/sfx/fire_02_1.png');
		this.assets.LoadImage('fire_2_2',this.homeURL+'assets/images/sfx/fire_02_2.png');
		this.assets.LoadImage('fire_2_3',this.homeURL+'assets/images/sfx/fire_02_3.png');
		this.assets.LoadImage('fire_2_4',this.homeURL+'assets/images/sfx/fire_02_4.png');
		this.assets.LoadImage('tires_1',this.homeURL+'assets/images/sfx/TireTracks_1.png');
		this.assets.LoadImage('tires_2',this.homeURL+'assets/images/sfx/TireTracks_2.png');
		this.assets.LoadImage('tires_3',this.homeURL+'assets/images/sfx/TireTracks_3.png');
		this.assets.LoadImage('tires_4',this.homeURL+'assets/images/sfx/TireTracks_4.png');

		if(this.config.sound_Effects.RaceMusic)
			this.assets.LoadSound('raceMusic',this.homeURL+'assets/sounds/'+this.config.sound_Effects.RaceMusic.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.RaceMusic.audio_ogg,true);
		if(this.config.sound_Effects.RedLight)
			this.assets.LoadSound('RedLight',this.homeURL+'assets/sounds/'+this.config.sound_Effects.RedLight.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.RedLight.audio_ogg);
		if(this.config.sound_Effects.YellowLight)
			this.assets.LoadSound('YellowLight',this.homeURL+'assets/sounds/'+this.config.sound_Effects.YellowLight.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.YellowLight.audio_ogg);
		if(this.config.sound_Effects.GreenLight)
			this.assets.LoadSound('GreenLight',this.homeURL+'assets/sounds/'+this.config.sound_Effects.GreenLight.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.GreenLight.audio_ogg);
		if(this.config.sound_Effects.typo)
			this.assets.LoadSound('typo',this.homeURL+'assets/sounds/'+this.config.sound_Effects.typo.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.typo.audio_ogg);
		if(this.config.sound_Effects.engine1)
			this.assets.LoadSound('engine1',this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine1.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine1.audio_ogg);
		if(this.config.sound_Effects.engine2)
			this.assets.LoadSound('engine2',this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine2.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine2.audio_ogg);
		if(this.config.sound_Effects.crash)
			this.assets.LoadSound('crash',this.homeURL+'assets/sounds/'+this.config.sound_Effects.crash.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.crash.audio_ogg);
		if(this.config.sound_Effects.cheer)
			this.assets.LoadSound('cheer',this.homeURL+'assets/sounds/'+this.config.sound_Effects.cheer.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.cheer.audio_ogg);
		
		this.assets.Start(this.LoadedGameData,this);
	}
	
	this.LoadedGameData=LoadedGameData;function LoadedGameData(){
		console.log('loaded game data');
		var elements=JSON.parse(this.assets.Data.Files.typingSentence);
		var i,j,element;
		this.sentences=new Array();
		this.sentence='';
		this.currentLetter=0;
		this.currentSentence=0;
		this.sentenceAudio=false;
		this.hints=this.config.gameSettings.difficulty[this.difficulty].hintCount;
		for(i=0;i<this.config.gameSettings.difficulty[this.difficulty].sentenceCount;i++){
			j=this.trackElements[i]%elements.length;
			element=elements[j];
			elements.splice(j,1);
			this.sentences[i]={
				"text":element.sentence.trim(),
				"start":this.sentence.length
			}
			if(element.audio_mp3 && element.audio_ogg){
				this.assets.LoadSound('sentenceAudio_'+i,this.homeURL+'assets/sounds/'+element.audio_mp3,this.homeURL+'assets/sounds/'+element.audio_ogg);
				this.sentences[i].text=this.sentences[i].text.toLowerCase();
			}else{
				this.assets.Data.Sounds['sentenceAudio_'+i]=null;
			}
			this.sentence+=this.sentences[i].text;
		}
		this.trackLength=this.sentence.length*this.config.gameSettings.settings.letterTrackSize;
		this.assets.Start(this.LoadedGameSentence,this);
	}
	
	this.broadcastReadyStatus=broadcastReadyStatus;function broadcastReadyStatus(player){//resets ready status for this player
		console.log('ready status');
		console.log(player);
		console.log(this.player);
		if(this.player.info.id!=player.id)
			this.cars[this.player.carID].broadcastReady=false;
	}
	
	this.setCurrentSentence=setCurrentSentence;function setCurrentSentence(index){
		this.currentSentence=index;
		if(this.assets.Data.Sounds['sentenceAudio_'+index]){
			this.sentenceAudio=this.assets.Data.Sounds['sentenceAudio_'+index];
			this.playSentenceAudio=true;
		}else{
			this.sentenceAudio=null;
			this.playSentenceAudio=false;
		}
		this.hintStart=this.time-this.config.gameSettings.settings.hintDuration;
	}

	this.LoadedGameSentence=LoadedGameSentence;function LoadedGameSentence(){
		this.loadingStage=2;
		this.setCurrentSentence(0);
		this.status='lobby';
		
		if(GSP && this.gameType=='multi'){
			var data={'event':'requestReadyStatus'};
			console.log('broadcasting request for ready status');
			GSP.multiplayer.update(data);
		}
		
		if(this.assets.Data.Sounds.raceMusic){
			this.assets.Data.Sounds.raceMusic.sound.loop=true;
			this.assets.Data.Sounds.raceMusic.Play();
		}
	}
	
	this.getHtmlSentence=getHtmlSentence;function getHtmlSentence(){
		var start,end,letter,pos;
		if(this.currentLetter>=this.sentence.length){
			start=this.sentences[this.sentences.length-1].text;
			letter=end='';
		}else{
			pos=this.currentLetter-this.sentences[this.currentSentence].start;
			start=this.sentences[this.currentSentence].text.substring(0,pos);
			letter=this.sentences[this.currentSentence].text.substring(pos,pos+1);
			end=this.sentences[this.currentSentence].text.substring(pos+1,this.sentences[this.currentSentence].text.length);
		}
		return(start+'<u id="sentenceLetter" style="color:#f00">'+letter+'</u>'+end);
	}
	
	this.startGame=startGame;function startGame(){
		var cfgUrl=this.config.gameSettings.difficulty[this.difficulty].elementsUrl;
		if(cfgUrl.indexOf('http://')<0)cfgUrl=this.homeURL+'config/'+cfgUrl;
		this.assets.LoadFile('typingSentence',cfgUrl);
		this.assets.Start(this.LoadedGameElements,this);
	}
		
	this.LoadedGameElements=LoadedGameElements;function LoadedGameElements(){
		var i,j,trackElements=new Array();
		var elements=JSON.parse(this.assets.Data.Files.typingSentence);
		for(i=0;i<this.config.gameSettings.difficulty[this.difficulty].sentenceCount;i++){
			j=Math.floor(Math.random()*elements.length);
			trackElements[i]=j;
			elements.splice(j,1);
		}
		trackElements=JSON.stringify(trackElements);
		
		this.trackPan=0;
		this.trackPos=0;
		this.finished=false;
		this.trackElements=false;
		this.endPos=0;
		if(this.gameType=='single'){//setup cars for singleplayer
			this.cars=[
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),0),
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),1),
				new CpcPlayer(this,this.player.carType,2),
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),3),
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),4)
			];
			this.trackElements=JSON.parse(trackElements);
			this.LoadGameData();
		}else{//setup cars for multiplayer
			this.cars=new Array();
			this.player.carID=0;
			this.multiGameStarted=false;
			console.log('proposing data:'+trackElements);
			if(GSP)GSP.multiplayer.joinGame({data : trackElements});
		}
	}
	
	this.lobby=lobby;function lobby(){
		var go=true;
		if(this.gameType=='multi' && !this.multiGameStarted){
			go=false;
		}
		for(i=0;i<this.cars.length;i++){
			if(this.gameType!='multi'){
				if(!this.cars[i].ready())go=false;
			}else this.cars[i].ready();
			this.cars[i].Run();
		}
		//go=false;
		if(go){
			//retreiving and broadcasting high score
			if(GSP)GSP.getPlayerBestScores({},function(status, data){
				game.player.points=parseInt(data.points);
				game.player.rank=parseInt(data.rank);
				game.player.highScore=parseInt(data.score);
				var data={
					'event':'highScore',
					'points':game.player.points,
					'rank':game.player.rank,
					'highScore':game.player.highScore
				};
				
				var car=game.cars[game.player.carID];
				car.totalPoints=game.player.points;
				car.rank=game.player.rank;
				car.highScore=game.player.highScore;
				if(game.gameType=='multi')if(GSP)GSP.multiplayer.update(data);
			});

			this.status='redlight';
			this.UI.setSentence('Arial',26);
			this.raceTime=this.time;
			if(this.assets.Data.Sounds.RedLight)this.assets.Data.Sounds.RedLight.Play();
			var obj=document.getElementById('quitButtonContainer');
			if(obj)obj.style.zIndex=15;
		}
	}
	
	this.addMplayer=addMplayer;function addMplayer(player, players){
		var i,add=true,ID,obj;
		if(this.player.info.id==player.id)add=false;
		for(i=0;i<this.cars.length;i++)if(this.cars[i].id==player.id)add=false;
		if(add){
			console.log('addmplayer');
			console.log(player);
			console.log(players);
			ID=this.cars.length;
			for(i=0;i<players.length;i++){
				if(player.id==players[i].id)ID=i;
			}
			this.cars[ID]=new Cmplayer(this,player,ID);
			obj=document.getElementById('laneName'+ID);
			if(obj)obj.innerHTML=player.name;
		}
	}
	
	this.onMultiplayerReady=onMultiplayerReady;function onMultiplayerReady(player,carType){
		if(player.id==this.player.info.id)return;
		var i,ID=-1;
		for(i=0;i<this.cars.length;i++)if(player.id==this.cars[i].id){ID=i;break;}
		if(ID<0){console.log('cannot set ready for unknown player ');console.log(this.cars);console.log(player);return;}
		console.log('setting ready for lane '+ID+' to cartype: '+carType);
		this.cars[ID].car.carType=parseInt(carType);
		this.cars[ID].receivedReady=true;
	}
	
	this.onMultiplayerType=onMultiplayerType;function onMultiplayerType(player,position,wpm,time){
		if(player.id==this.player.info.id)return;
		var i,ID=-1;
		for(i=0;i<this.cars.length;i++)if(player.id==this.cars[i].id){ID=i;break;}
		if(ID<0){console.log('cannot set position for unknown player ');console.log(this.cars);console.log(player);return;}
		console.log('setting position for lane '+ID+' to pos: '+position);
		this.cars[ID].setPosition(position,wpm,time+this.raceTime);
		if(this.status=='RaceReport')this.UI.status=false;
	}

	this.onMultiplayerERR=onMultiplayerERR;function onMultiplayerERR(player,errCount,time){
		if(player.id==this.player.info.id)return;
		var i,ID=-1;
		for(i=0;i<this.cars.length;i++)if(player.id==this.cars[i].id){ID=i;break;}
		if(ID<0){console.log('cannot set ERROR for unknown player ');console.log(this.cars);console.log(player);return;}
		if(this.cars[ID].ERR>=errCount)return;
		console.log('setting ERROR for lane '+ID+' to '+errCount);
		if(!this.cars[ID].errTarget)this.cars[ID].errTarget=0;
		if(this.cars[ID].errTarget>errCount)return;
		this.cars[ID].errTarget=errCount;
		for(i=this.cars[ID].ERR;i<parseInt(errCount);i++){
			this.cars[ID].error(time+this.raceTime);
		}
		if(this.status=='RaceReport')this.UI.status=false;
	}
	
	this.onMultiplayerHighScore=onMultiplayerHighScore;function onMultiplayerHighScore(player,points,rank,highScore){
		var i,ID=-1;
		if(player.id==this.player.info.id)ID=this.player.carID;
		else for(i=0;i<this.cars.length;i++)if(player.id==this.cars[i].id){ID=i;break;}
		if(ID<0){console.log('cannot set highScore for unknown player ');console.log(this.cars);console.log(player);return;}
		console.log('setting highScore for lane '+ID);
		this.cars[ID].totalPoints=points;
		this.cars[ID].rank=rank;
		this.cars[ID].highScore=highScore;
		console.log(this.cars);
	}
	
	this.crashPlayer=crashPlayer;function crashPlayer(player){
		if(player.id==this.player.info.id)return;
		var i,ID=-1;
		for(i=0;i<this.cars.length;i++)if(player.id==this.cars[i].id){ID=i;break;}
		if(ID<0){console.log('cannotcrash unknown player ');console.log(this.cars);console.log(player);return;}
		if(!this.multiGameStarted){
			console.log('removing player on lane '+ID);
			console.log(this.cars);
			this.cars.splice(ID,1);
			for(i=ID;i<this.cars.length;i++)this.cars[i].car.lane--;
			if(this.player.carID>ID)this.player.carID--;
			this.UI.status=false;
			console.log(this.cars);
			return;
		}
		if(status=='lobby'){
			this.cars[ID].car.carType=0;
			this.cars[ID].receivedReady=true;
		}
		if(this.cars[ID].crash || this.cars[ID].finished)return;
		console.log('crashing player on lane '+ID);
		this.cars[ID].ERR=this.config.gameSettings.difficulty[this.difficulty].errorsToSmoke-1;
		this.cars[ID].error();
		this.cars[ID].ERR=this.config.gameSettings.difficulty[this.difficulty].errorsToFire-1;
		this.cars[ID].error();
		this.cars[ID].ERR=this.config.gameSettings.difficulty[this.difficulty].errorsToCrash-1;
		this.cars[ID].error();
	}
	
	this.gameOver=gameOver;function gameOver(newStatus){
		this.desiredStatus=newStatus;
		if(this.gameType!='multi'){
			this.onLeaveGame();
			return;
		}
		if(GSP && GSP.multiplayer && GSP.multiplayer.isInGame())GSP.multiplayer.leaveGame();
		else this.onLeaveGame();
	}
	
	this.onLeaveGame=onLeaveGame;function onLeaveGame(){
		//stopping sounds
		var soundSetting=this.soundOn;
		this.soundOn=true;
		this.UI.soundButtonPress(true,true);
		this.soundOn=soundSetting;
		this.cars=null;
		this.lastGameType=this.gameType;
		this.gameType=false;
		switch(this.desiredStatus){
			case('MpError'):
				this.status=false;
				break;
			case('LoadGarrage'):
				this.LoadGarrage();
				break;
			case('startNewGame'):
				this.gameType=this.lastGameType;
				this.startGame();
				break;
			default:
				if(this.desiredStatus)this.status=this.desiredStatus;
				break;
			}
		this.desiredStatus=false;
	}
	
	
	this.playing=playing;function playing(){
		this.trackPos+=this.config.gameSettings.settings.backgroundSpeed;
//		if(this.finished)return;
		var i,finished=true,soundon;
		
		if(this.playSentenceAudio && this.sentenceAudio && this.status=='playing'){
			soundon=this.soundOn;
			this.soundOn=true;
			this.sentenceAudio.Play();
			this.soundOn=soundon;
			this.playSentenceAudio=false;
		}
		
		if(this.sentenceAudio){
			var vol=this.config.gameSettings.settings.hushVolume;
			if(this.sentenceAudio.sound.paused){
				if(this.assets.Data.Sounds.raceMusic && this.assets.Data.Sounds.raceMusic.sound.volume<1.0)this.assets.Data.Sounds.raceMusic.sound.volume=1.0;
				if(this.assets.Data.Sounds.RedLight && this.assets.Data.Sounds.RedLight.sound.volume<1.0)this.assets.Data.Sounds.RedLight.sound.volume=1.0;
				if(this.assets.Data.Sounds.YellowLight && this.assets.Data.Sounds.YellowLight.sound.volume<1.0)this.assets.Data.Sounds.YellowLight.sound.volume=1.0;
				if(this.assets.Data.Sounds.GreenLight && this.assets.Data.Sounds.GreenLight.sound.volume<1.0)this.assets.Data.Sounds.GreenLight.sound.volume=1.0;
			}else{
				if(this.assets.Data.Sounds.raceMusic && this.assets.Data.Sounds.raceMusic.sound.volume>vol)this.assets.Data.Sounds.raceMusic.sound.volume=vol;
				if(this.assets.Data.Sounds.RedLight && this.assets.Data.Sounds.RedLight.sound.volume>vol)this.assets.Data.Sounds.RedLight.sound.volume=vol;
				if(this.assets.Data.Sounds.YellowLight && this.assets.Data.Sounds.YellowLight.sound.volume>vol)this.assets.Data.Sounds.YellowLight.sound.volume=vol;
				if(this.assets.Data.Sounds.GreenLight && this.assets.Data.Sounds.GreenLight.sound.volume>vol)this.assets.Data.Sounds.GreenLight.sound.volume=vol;
			}
		}
		
		if(this.time-this.typeTime>this.config.gameSettings.settings.warningIdleTime && !this.finished){//warning idle out
			var obj=document.getElementById('noTypeHint');
			if(obj)obj.style.display='block';
		}
		
		if(this.time-this.typeTime>this.config.gameSettings.settings.maxIdleTime){//idle out
			var obj=document.getElementById('raceInput');
			var key;
			if(obj){
				if(this.sentence.substr(this.currentLetter,1)==' ')key='.';else key=' ';
				for(i=this.cars[this.player.carID].ERR;i<=this.config.gameSettings.difficulty[this.difficulty].errorsToCrash;i++){
					obj.value+=key;
					this.keyPressed();
				}
			}
		}
		
		for(i=0;i<this.cars.length;i++){
			this.cars[i].Run();
			if(this.cars[i].type!='AI' && !this.cars[i].finished && !this.cars[i].crash){
				finished=false;
			}
		}
		var car=this.cars[this.player.carID];
		if(finished && !this.finished){
			for(i=0;i<this.cars.length;i++)if(this.cars[i].type=='AI')this.cars[i].finishRace();
			if(this.assets.Data.Sounds.raceMusic)this.assets.Data.Sounds.raceMusic.Stop();
			this.finished=true;
			for(i=0;i<this.cars.length;i++)if(this.cars[i].type=='PC')break;
			var time=3000;
			if(this.cars[i].car.drawPosition<500)time+=6*(500-this.cars[i].car.drawPosition);
			setTimeout(function(){
				game.status='RaceReport';
				var car=game.cars[game.player.carID];
				if(car.finished && !car.crash)
					saveScore();
			},time);
		}else if(this.gameType=='multi' && (car.crash || car.finished) && !this.finished){
			if(this.assets.Data.Sounds.raceMusic)this.assets.Data.Sounds.raceMusic.Stop();
			this.finished=true;
			var time=2000;
			setTimeout(function(){
				game.status='RaceReport';
				var car=game.cars[game.player.carID];
				if(car.finished && !car.crash)
					saveScore();
			},time);
		}
		
	}
	
	
	//save score functions
	this.getScore=getScore;function getScore(){
		var car=this.cars[this.player.carID];
		return(car.WPM);
	}
	
	this.calculateLevel=calculateLevel;function calculateLevel(car){
		var LevelConfig=this.assets.Data.Files.LevelConfig;
		if(!LevelConfig){console.log('no levelConfig data');return null;}
		LevelConfig=JSON.parse(LevelConfig);
		var i;
		if(!car.highScore)car.highScore=0;
		if(car.WPM>car.highScore)car.highScore=car.WPM;
		for(i=0;i<LevelConfig.length;i++)if(car.highScore>=LevelConfig[i].low && car.highScore<=LevelConfig[i].high){
			return(LevelConfig[i]);
		}
		return(LevelConfig[0]);
	}
	
	this.getPoints=getPoints;function getPoints(carP){
		var car=carP;if(!car)car=this.cars[this.player.carID];
		if(car.crash)return(0);
		if(this.gameType!='multi')return(3);
		var pos=this.getPosition(car)
		if(pos>=this.cars.length)return(3);
		var i,bank=0;
		for(i=0;i<this.cars.length;i++){
			this.cars[i].level=this.calculateLevel(this.cars[i]);
			bank+=this.cars[i].level.points;
		}
		for(i=0;i<this.cars.length;i++)if(this.cars[i]!=car && !this.cars[i].crash && (this.cars[i].WPM>car.WPM || (this.cars[i].WPM==car.WPM && this.cars[i].finishTime<car.finishTime) ) ){
			bank-=this.cars[i].level.points;
		}
		bank-=car.level.points;
		return(bank);
	}
	
	this.getPosition=getPosition;function getPosition(carP){
		var car=carP;if(!car)car=this.cars[this.player.carID];
		var pos=1;
		for(i=0;i<this.cars.length;i++)if(this.cars[i]!=car && !this.cars[i].crash && (this.cars[i].WPM>car.WPM || (this.cars[i].WPM==car.WPM && this.cars[i].finishTime<car.finishTime) ) )pos++;
		return(pos);
	}
	
	this.getRaceTime=getRaceTime;function getRaceTime(){
		var car=this.cars[this.player.carID];
		var time;
		if(car.crash)time=car.crashTime;else time=car.finishTime;
		time-=this.raceTime;
		if(time<0)time=0;
		var minutes=Math.floor(time/60000);
		time-=minutes*60000;
		var seconds=Math.floor(time/1000);
		if(minutes<=9)minutes='0'+minutes;
		if(seconds<=9)seconds='0'+seconds;
		return(minutes+':'+seconds);
	}
	
	this.getErrors=getErrors;function getErrors(){
		var car=this.cars[this.player.carID];
		return(car.ERR);
	}
	
	this.computePoints=computePoints;function computePoints(){
		var i;
		if(!this.cars)return;
		for(i=0;i<this.cars.length;i++)this.cars[i].points=3;
	}
	
	this.keyPressed=keyPressed;function keyPressed(){
		if(game.status!='playing' && game.status!='greenlight')return;
		if(this.cars[this.player.carID].crash)return;
		if(this.cars[this.player.carID].finished)return;
		var obj=document.getElementById('raceInput');
		if(!obj)return;
		if(obj.lastSize>=obj.value.length)return;
		var keys=obj.value.substring(obj.lastSize,obj.value.length);
		if(this.sentenceAudio)keys=keys.toLowerCase();
		obj.lastSize=obj.value.length;
		var i,key;
		this.typeTime=this.time;
		obj=document.getElementById('noTypeHint');
		if(obj)obj.style.display='none';
		for(i=0;i<keys.length;i++){
			key=keys[i];
			if(key==this.sentence.substr(this.currentLetter,1)){//correct key
				this.currentLetter++;
				this.cars[this.player.carID].position++;
				this.cars[this.player.carID].WPM=(this.cars[this.player.carID].position*12000)/(game.time-game.raceTime);
				if(key==' ' || key=='.' || key==',' || key==';' || this.currentLetter>=this.sentence.length){//word completed
					if(this.gameType=='multi'){
						var data={
							'event':'update',
							'position':this.cars[this.player.carID].position,
							'wpm':this.cars[this.player.carID].WPM,
							'time':(this.time-this.raceTime)
						};
						console.log('broadcasting update');
						if(GSP)GSP.multiplayer.update(data);
					}
					this.cars[this.player.carID].car.position=this.cars[this.player.carID].position*this.config.gameSettings.settings.letterTrackSize;
					this.SFX.carMoves(this.player.carID);
				}
				this.UI.setSentence('Arial',26);
				if(this.currentLetter>=this.sentence.length){//end race
					this.cars[this.player.carID].finished=true;
					if(this.assets.Data.Sounds.cheer)this.assets.Data.Sounds.cheer.Play();
					this.cars[this.player.carID].finishTime=this.time;
					this.endPos=this.trackPos;
				}
		 	}else{//wrong key
				this.cars[this.player.carID].ERR++;
				if(this.gameType=='multi'){
					var data={
						'event':'error',
						'errCount':this.cars[this.player.carID].ERR,
						'time':(this.time-this.raceTime)
					};
					console.log('broadcasting error');
					if(GSP)GSP.multiplayer.update(data);
				}
				if(this.assets.Data.Sounds.typo)this.assets.Data.Sounds.typo.Play();
				if(this.cars[this.player.carID].ERR>=this.config.gameSettings.difficulty[this.difficulty].errorsToCrash){//crashing
					this.cars[this.player.carID].ERR=this.config.gameSettings.difficulty[this.difficulty].errorsToCrash;
					this.cars[this.player.carID].crash=true;
					this.cars[this.player.carID].crashTime=this.time;
					if(this.assets.Data.Sounds.crash)this.assets.Data.Sounds.crash.Play();
				}else if(this.cars[this.player.carID].ERR==this.config.gameSettings.difficulty[this.difficulty].errorsToSmoke){//engine smoking
					this.SFX.addEffect('smoke_1',this.player.carID);
				}else if(this.cars[this.player.carID].ERR==this.config.gameSettings.difficulty[this.difficulty].errorsToFire){//on fire
					this.SFX.addEffect('fire_1',this.player.carID);
				}
			}
		}
	}
	
	this.LoadGarrage=LoadGarrage;function LoadGarrage(){
		this.assets.LoadImage('garrageBG',this.homeURL+'assets/images/garrage/garagegrayBG.png');
		this.assets.LoadImage('garrageClose',this.homeURL+'assets/images/translate/'+this.language+'/garageClosed.png');
		this.assets.LoadImage('garrageHolders',this.homeURL+'assets/images/garrage/garagePlatformHolders.png');
		this.assets.LoadImage('garrageArrow',this.homeURL+'assets/images/garrage/GarageArrow.png');
		this.assets.Start(this.LoadedGarrageData,this);
	}
	
	this.LoadedGarrageData=LoadedGarrageData;function LoadedGarrageData(){
		this.status='garrage';
	}
	
	this.Run=Run;function Run(){
		var date=new Date();var Time=date.getTime();this.frameTime=Time-this.time;this.time=Time;
		if(this.gameDiv){
			cw=this.gameDiv.clientWidth;ch=this.gameDiv.clientHeight;
			if(cw/ch>960/640)cw=ch*960/640;else ch=cw*640/960;
			if(this.clientWidth!=cw || this.clientHeight!=ch){
				this.Resize(cw,ch);
			}
		}
		//debugStr(this.status);
		switch(this.status){
			case(0)://initial loading
				if(this.LoadOk())this.status='main menu';
				break;
			case('lobby'):
				this.lobby();
				break;
			case('redlight'):
				this.typeTime=this.time;
				if(this.time-this.raceTime>this.config.gameSettings.settings.lightTimer){this.status='yellowlight';if(this.assets.Data.Sounds.YellowLight)this.assets.Data.Sounds.YellowLight.Play();this.raceTime=this.time;}
				break;
			case('yellowlight'):
				this.typeTime=this.time;
				if(this.time-this.raceTime>this.config.gameSettings.settings.lightTimer){this.status='greenlight';if(this.assets.Data.Sounds.GreenLight)this.assets.Data.Sounds.GreenLight.Play();this.raceTime=this.time;this.UI.focusInput();}
				break;
			case('greenlight'):
				if(this.time-this.raceTime>this.config.gameSettings.settings.lightTimer){this.status='playing';this.typeTime=this.time;}
			case('playing'):
				this.playing();
				break;
			default:break;
		}
		if(this.UI)this.UI.Run(this.status);
		if(this.assets){
			if(this.assets.show || this.status=='waiting' || this.adsRunning){
				if(this.UI)this.UI.show(false);
			}else{
				if(this.UI)this.UI.show(true);
			}
			this.assets.Run();
		}
	}
	
	function RunMain(){game.Run();}
	this.Load();
}

function CpcPlayer(game,type,lane){
	this.type='PC';
	game.player.carID=lane;
	this.car=new Ccar(game,type,lane);
	this.position=0;
	this.crash=false;
	this.finished=false;
	this.ERR=0;
	this.WPM=0;
	this.name=game.player.info.name;
	this.crashTime=0;
	this.finishTime=0;
	this.broadcastReady=false;
	
	this.ready=ready;function ready(){
//		if(game.gameType=='multi' && game.multiGameStarted && !this.broadcastReady){
		if(game.gameType=='multi' && !this.broadcastReady){
			var data={
				'event':'readyToGo',
				'car':this.car.carType
			};
			console.log('broadcasting ready status');
			if(GSP)GSP.multiplayer.update(data);
			this.broadcastReady=true;
		}
		
		this.car.goToStart();
		if(this.car.ready)return(true);
		return(false);
	}
	
	this.Run=Run;function Run(){
		if(!this.crash && !this.finished)this.WPM=(this.position*12000)/(game.time-game.raceTime);
		if(this.finished && !this.crash)this.car.position+=game.config.gameSettings.settings.letterTrackSize;
		else if(this.crash)this.car.position-=game.config.gameSettings.settings.backgroundSpeed;
		else if(this.car.position>game.trackLength)this.car.position=game.trackLength;
		this.car.Run();
		if(this.car.drawPosition>500 && !this.finished && !this.crash)game.trackPan=this.car.drawPosition-500;
	}
	
	this.Draw=Draw;function Draw(){
		this.car.Draw();
	}
}

function getSearchParameters() {
      var prmstr = window.location.search.substr(1);
      return prmstr != null && prmstr != "" ? transformToAssocArray(prmstr) : {};
}

function transformToAssocArray( prmstr ) {
    var params = {};
    var prmarr = prmstr.split("&");
    for ( var i = 0; i < prmarr.length; i++) {
        var tmparr = prmarr[i].split("=");
        params[tmparr[0]] = tmparr[1];
    }
    return params;
}

function isJsonString(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}