// JavaScript Document
// initiate GSP
//$(document).ready(function() {
function startGSP(days,game){
		if(!days)days=0;
		if(typeof GSP === 'undefined' || !GSP){
			GSP=false;
			game.startLoad();
			alert('Server not responding, social network functions not available.\nPlease try again in a few minutes.');
			return;
		}
		console.log('starting GSP');
		if(game.GSPStart){
			game.startLoad();
			return;
		}
		game.GSPStart=false;
		GSP.init({
//		 	domain : "http://gsp-test.choyo.cloudbees.net/",
			applicationId : "B038C5A5912E9C28",//DCB17726AD988A4D
			loginPeriod : days,
			debugMode : true,
			afterInit : function(status, data) {
				console.log('GSP started');
				game.GSPStart=true;
				if(game.GSPMultiplayer)return;
				game.GSPMultiplayer=false;
				game.startLoad();
				GSP.multiplayer.connect({
					afterInit : function(status, player) {
						game.GSPMultiplayer=true;
						console.log("afterInit");
						console.log(player);
						game.player.info=player;
					},
					onJoinGame : function(gameData) {
						var i,found=false;
						console.log("joined game: "+game+' game data: '+gameData);
						console.log(game);
						console.log(gameData);
						console.log('got data: '+gameData.data);
//						game.gameData=gameData;
						game.trackElements=JSON.parse(gameData.data);
						game.LoadGameData();
						if(!game.player.info.id)game.player.info=GSP.multiplayer.getCurrentPlayer();
						for(i=0;i<gameData.players.length;i++)if(game.player.info.id==gameData.players[i].id){game.player.carID=i;found=true;break;}
						if(!found){console.log('failed to find own player !');game.status='main menu';GSP.multiplayer.leaveGame(function(){console.log('abandoned game');});}
						game.cars[game.player.carID]=new CpcPlayer(game,game.player.carType,game.player.carID);
						if(game.player.carID>0)game.status='waiting';
						console.log('ID ='+game.player.carID);
						console.log('-----------get players:---------------');
						console.log(getGamePlayers());
						console.log('---------END get players:-------------');
					},
					onLeaveGame :function(){
						game.onLeaveGame();
					},
					onGameStart : function(gameData) {
						game.multiGameStarted=true;
						console.log("onGameStart");
					},
					onPlayerJoin : function(player, players) {
						game.addMplayer(player, players);
						game.broadcastReadyStatus(player);
						console.log("onPlayerJoin");
					},
					onPlayerLeave : function(player) {
						console.log("onPlayerLeft");
						game.crashPlayer(player);
					},
					onPlayerUpdate : function(player, data) {
						var message=JSON.parse(data);
						console.log(message);
						switch(message.event){
							case('update'):
								game.onMultiplayerType(player,message.position,message.wpm,message.time);
								break;
							case('error'):
								game.onMultiplayerERR(player,message.errCount,message.time);
								break;
							case('readyToGo'):
								game.onMultiplayerReady(player,message.car);
								break;
							case('highScore'):
								game.onMultiplayerHighScore(player,message.points,message.rank,message.highScore);
								break;
							case('requestReadyStatus'):
								game.broadcastReadyStatus(player);
								break;
							default:console.log('unknown update: '+message.event);break;
						}
					},
					onError : function(code, error) {
						console.log("Error code: "+code+' error: '+error);
						switch(code){
							case(0):case(1001):
								GSP=false;
								game.startLoad();
								break;
							case(1002):case(1004):case(1005):case(1006):
								break;
							default:
								game.GSPStart=true;
								game.GSPMultiplayer=false;
								game.gameOver('MpError');
								break;
						}
					},
					playerMetadata : ""
				});
				
			   GSP.multiplayer.addOnlineStatusListener(function(status) {
					var obj;
					obj=document.getElementById('statusBarMainMenu');
					if(obj)obj.style.display='block';
					
					obj=document.getElementById('statusBarRace');

					if(obj)obj.style.display='block';
					
					obj=document.getElementById('onlinePlayers');
					if(obj)obj.innerHTML=status.players;
					obj=document.getElementById('activeGames');
					if(obj)obj.innerHTML=status.games;
			   });
			},
			afterPlayerLogin : function(data) {
				game.player={
					info:data.player,
					carType:0
				}
				loadPlayerData();
				var cookieSave=getCookie('typingRaceGameScore');
				var coins=false;
				setCookie('typingRaceGameScore','',0);
				if(cookieSave!=""){
					cookieSave=JSON.parse(cookieSave);
					console.log('saving:');	console.log(cookieSave);
					GSP.saveResult(cookieSave, function(status, data) {
						if(status==200){
							game.player.coins+=Math.round(cookieSave.points/2);
							savePlayerData();
						}
					});
				}
			}
		});
}

	function login(provider) {
		if(!GSP)return;
		if(!GSP.isInitiated())return;
		if (GSP.isPlayerLogin()) {
			alert("you are already logged in");
		} else {
			var str=window.location+'#end';
			str=str.replace(/\/#end/, '');
			str=str.replace(/#end/, '');
			GSP.login({"provider" : provider , "redirect_url" : str }, function(status, data) {
				if(status == 200) {
					setTimeout(function() {location.href = data.login_url;}, 1000);
				} else {
					console.log("login error: " + data.messages)
				}
			});
		}
	}

	function saveScore() {
		if(!GSP)return;
		if(!GSP.isInitiated())return;
		var points=game.getPoints();
		var saveData={
			"score" : game.getScore(),
			"points": points,
			"payload":'{"position":"'+game.getPosition()+'","time":"'+game.getRaceTime()+'","errors":"'+game.getErrors()+'"}'
		};
		game.player.coins+=Math.round(points/2);
		if(!GSP.isPlayerLogin())return;
		console.log('saving...');
		console.log(saveData);
		GSP.saveResult(saveData, function(status, data) {
			if(status==200)savePlayerData();
		});
	}
	
	function loadPlayerData(){
//		GSP.deletePlayerData({"key":1},function(status,data){alert('cleaned');});
		game.player.ownedCars=new Array(true);
		game.player.carType=0;
//		game.player.car.carType=game.player.carType;
		game.player.coins=0;
		GSP.getPlayerData({"key":1},function(status,data){
			if(data.type!='NO_CONTENT' && typeof data.dataString !== 'undefined'){
				var ret=JSON.parse(data.dataString);
				if(typeof ret.car !== 'undefined')game.player.carType=parseInt(ret.car);
				if(typeof ret.cars !== 'undefined')game.player.ownedCars=ret.cars;
				if(typeof ret.coins !== 'undefined')game.player.coins=parseInt(ret.coins);
//				game.player.car.carType=game.player.carType;
			}
			game.status='main menu set';
		});
	}
	
	function savePlayerData(){
		if(!GSP)return;
		if(!GSP.isInitiated())return;
		if(!GSP.isPlayerLogin())return;
		var cars,car,coins;
		car=game.player.carType;if(!car)car=0;
		cars=game.player.ownedCars;if(!cars)cars=new Array();
		coins=game.player.coins;if(!coins)coins=0;
		var data={
			'cars':cars,
			'car':car,
			'coins':coins
		};
		console.log('saving player data:');console.log(data);
		GSP.savePlayerData({
				"key":1,
				"data":JSON.stringify(data)
			},function(status, data){
				if(status == 200){
					var obj=document.getElementById('loadingTextContainer');if(obj)obj.style.display='none';
					if(game.status=='garrage'){
						game.UI.Gcar.DrawGarrage();
						var obj=document.getElementById('coinsContainer');if(obj)obj.innerHTML=coins;
					}
				}
			});
	}
	
	function getGamePlayers(){
		var theplayers=GSP.multiplayer.getPlayers();
		var ret=new Array();
		for (var key in theplayers) {
			if (key === 'length' || !theplayers.hasOwnProperty(key)) continue;
			ret[ret.length]=theplayers[key].player;
		}
		return(ret);
	}
	
	function clearGet(){
		var newURL;
		var str=location.href;
		var endURL=parseInt(str.lastIndexOf('?'));
		if(endURL>0){
			newURL=str.substr(0,endURL);
		}else{
			newURL=str;
		}
		location.href=newURL;
	}
	
	function setCookie(cname, cvalue, time) {
    	var d = new Date();
	    d.setTime(d.getTime() + (time));

    	var expires = "expires="+d.toGMTString();
	    document.cookie = cname + "=" + cvalue + "; " + expires;
	}
	function getCookie(cname) {
 	   var name = cname + "=";
    	var ca = document.cookie.split(';');
	    for(var i=0; i<ca.length; i++) {
    	    var c = ca[i];
        	while (c.charAt(0)==' ') c = c.substring(1);
	        if (c.indexOf(name) != -1) return c.substring(name.length, c.length);
    	}
	    return "";
	}
	
	
	
//////////////////////////google adds functions//////////////////////////////////////////////////////////////
var adsManager;
var adsLoader;
var adDisplayContainer;
var intervalTimer;
var adTimer=false;
var expireInterval;
var videoContent = false;

function createAdDisplayContainer() {
  // We assume the adContainer is the DOM id of the element that will house
  // the ads.
  var obj=document.getElementById('UIAdsContainer');
  if(obj){
		var html='<div id="mainContainer" style="position:absolute;z-index:999;margin-top:0px;margin-left:0px;">';
			html+='<div id="content"><video id="contentElement" style="width:'+(game.config.gameSettings.settings.adsWidth*game.UI.scaleVal)+'px; height:'+(game.config.gameSettings.settings.adsHeight*game.UI.scaleVal)+'px;"/></div>';
			html+='<div id="adContainer">';
   				html+='<div id="overlay ad container"></div>';
			html+='</div>';
		html+='</div>';
		obj.innerHTML=html;
		obj.style.marginLeft=((960-game.config.gameSettings.settings.adsWidth)/2*game.UI.scaleVal)+'px';
		obj.style.marginTop=((640-game.config.gameSettings.settings.adsHeight)/2*game.UI.scaleVal)+'px';
		var adsContainer=document.getElementById('adContainer');
		adDisplayContainer = new google.ima.AdDisplayContainer(adsContainer);
		videoContent = document.getElementById('contentElement');
  }
}

function requestAds() {
  if(typeof google === 'undefined'){game.adsRunning=false;return;}
  if(typeof google.ima === 'undefined'){game.adsRunning=false;return;}
  // Create the ad display container.
  createAdDisplayContainer();
  // Initialize the container, if requestAds is invoked in a user action.
  // This is only needed on iOS/Android devices.
  adDisplayContainer.initialize();
  // Create ads loader.
  adsLoader = new google.ima.AdsLoader(adDisplayContainer);
  // Listen and respond to ads loaded and error events.
  adsLoader.addEventListener(
      google.ima.AdsManagerLoadedEvent.Type.ADS_MANAGER_LOADED,
      onAdsManagerLoaded,
      false);
  adsLoader.addEventListener(
      google.ima.AdErrorEvent.Type.AD_ERROR,
      onAdError,
      false);

  var adsRequest = new google.ima.AdsRequest();
	var defaultTag="http://googleads.g.doubleclick.net/pagead/ads?ad_type=video_text_image_flash&client=ca-games-pub-0257676513671624&description_url=http%3A%2F%2Flocalhost%2Ftyping%2520race%2F&videoad_start_delay=0&hl=en&max_ad_duration=30000";
	if(game.config.gameSettings.settings.adsTagUrl)
		adsRequest.adTagUrl = game.config.gameSettings.settings.adsTagUrl;
	else
		adsRequest.adTagUrl = defaultTag;

  // Specify the linear and nonlinear slot sizes. This helps the SDK to
  // select the correct creative if multiple are returned.
  var adsW=parseInt(game.config.gameSettings.settings.adsWidth*game.UI.scaleVal);
  var adsH=parseInt(game.config.gameSettings.settings.adsHeight*game.UI.scaleVal);
  adsRequest.linearAdSlotWidth = adsW;
  adsRequest.linearAdSlotHeight = adsH;

  adsRequest.nonLinearAdSlotWidth = adsW;
  adsRequest.nonLinearAdSlotHeight = adsH;
  console.log(adsW+' '+adsH);

  adsLoader.requestAds(adsRequest);
}

function onAdsManagerLoaded(adsManagerLoadedEvent) {
  // Get the ads manager.
  adsManager = adsManagerLoadedEvent.getAdsManager(
      videoContent);  // See API reference for contentPlayback

  // Add listeners to the required events.
  adsManager.addEventListener(
      google.ima.AdErrorEvent.Type.AD_ERROR,
      onAdError);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.CONTENT_PAUSE_REQUESTED,
      onContentPauseRequested);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.CONTENT_RESUME_REQUESTED,
      onContentResumeRequested);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.ALL_ADS_COMPLETED,
      onAdEvent);
  

  // Listen to any additional events, if necessary.
  adsManager.addEventListener(
      google.ima.AdEvent.Type.LOADED,
      onAdEvent);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.STARTED,
      onAdEvent);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.COMPLETE,
      onAdEvent);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.CLICK,
      onAdEvent);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.SKIPPED,
      onAdEvent);
  adsManager.addEventListener(
      google.ima.AdEvent.Type.USER_CLOSE,
      onAdEvent);


  try {
    // Initialize the ads manager. Ad rules playlist will start at this time.
    adsManager.init(game.config.gameSettings.settings.adsWidth*game.UI.scaleVal, game.config.gameSettings.settings.adsHeight*game.UI.scaleVal, google.ima.ViewMode.NORMAL);
    // Call play to start showing the ad. Single video and overlay ads will
    // start at this time; the call will be ignored for ad rules.
    adsManager.start();
  } catch (adError) {
    // An error may be thrown if there was a problem with the VAST response.
	console.log(adError);
  }
}

function onAdEvent(adEvent) {
  // Retrieve the ad from the event. Some events (e.g. ALL_ADS_COMPLETED)
  // don't have ad object associated.
  var ad = adEvent.getAd();
  console.log('-------------add event: '+adEvent.type+'-----------------');
  switch (adEvent.type) {
    case(google.ima.AdEvent.Type.LOADED):
	  game.adsRunning=true;
      // This is the first event sent for an ad - it is possible to
      // determine whether the ad is a video ad or an overlay.
      if (!ad.isLinear()) {
        // Position AdDisplayContainer correctly for overlay.
        // Use ad.width and ad.height.
      }
      break;
    case(google.ima.AdEvent.Type.STARTED):
		game.adsRunning=true;
      // This event indicates the ad has started - the video player
      // can adjust the UI, for example display a pause button and
      // remaining time.
      if (ad.isLinear()) {
        // For a linear ad, a timer can be started to poll for
        // the remaining time.
        intervalTimer = setInterval(
            function() {
              var remainingTime = adsManager.getRemainingTime();
            },
            300); // every 300ms
      }else{
	  	expireInterval=setTimeout(function(){
			game.adsRunning=false;
			clearTimeout(expireInterval);
		},30000);
	  }
      break;
    case(google.ima.AdEvent.Type.ALL_ADS_COMPLETED):
		game.adsRunning=false;
      break;
    case(google.ima.AdEvent.Type.COMPLETE):case(google.ima.AdEvent.Type.SKIPPED):case(google.ima.AdEvent.Type.USER_CLOSE):
		game.adsRunning=false;
      // This event indicates the ad has finished - the video player
      // can perform appropriate UI actions, such as removing the timer for
      // remaining time detection.
      if (ad.isLinear()) {
        clearInterval(intervalTimer);
      }
      break;
  }
}

function onAdError(adErrorEvent) {
  // Handle the error logging.
  console.log(adErrorEvent.getError());
  game.adsRunning=false;
  adsManager.destroy();
}

function onContentPauseRequested() {
  videoContent.pause();
  // This function is where you should setup UI for showing ads (e.g.
  // display ad timer countdown, disable seeking etc.)
  // setupUIForAds();
}

function onContentResumeRequested() {
  videoContent.play();
  // This function is where you should ensure that your UI is ready
  // to play content. It is the responsibility of the Publisher to
  // implement this function when necessary.
  // setupUIForContent();
}
