// JavaScript Document
function Cui(game){
	this.status=0;//current screen to be displayed
	this.handler=game;//the game object
	this.mainDiv=false;//html container for the interface elements
	this.scaleVal=1.0;//scale at which to resize everything (1.0 means that the game is at the original 960x640 screen size)
	this.LoadingPerc=0;//used internally in the loading screen to show how much is left to load
	this.raceCtx=false;//2d context for the canvas used during the race
	this.measuringCtx=false;//2d context for the canvas used to measure text sizes
	this.loginPanelOpen=false;//used to keep the status of the player button in the main menu
	
	this.Load=Load;function Load(){
		if(game.gameDiv){
			game.gameDiv.innerHTML+='<div id="UIContainer" onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;"></div>';
			game.gameDiv.innerHTML+='<div id="loadingContainer" align="center"><div id="loadingRaceLogo"></div><div id="loadingRaceText"></div><div id="loadingBarContainer" align="left"><div id="loadingBar"></div></div></div>';
			game.gameDiv.innerHTML+='<div id="UIAdsContainer" onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;"></div>';
		}
		this.mainDiv=document.getElementById('UIContainer');
		this.measuringCanvas=document.createElement("canvas");
		this.measuringCtx=this.measuringCanvas.getContext("2d");
	}
	
	this.show=show;function show(display){
		if(!this.mainDiv)return;
		var val;
		if(display)val='block';else val='none';
		if(this.mainDiv.style.display!=val)this.mainDiv.style.display=val;
		var obj=document.getElementById('loadingContainer');
		if(display)val='none';else val='block';
		if(obj.style.display!=val)obj.style.display=val;
		obj=document.getElementById('UIAdsContainer');
		if(obj.style.display!=val)obj.style.display=val;
	}
	
	this.Run=Run;function Run(gameStatus){
		var set=false;if(gameStatus==this.status)set=true;
		switch(gameStatus){
			case('login screen 1'):this.loginScreen1(set);break;
			case('login screen 2'):this.loginScreen2(set);break;
			case('lobby'):this.race(set);break;
			case('redlight'):case('yellowlight'):case('greenlight'):case('playing'):
				if(this.status)set=true;else set=false;
				this.race(set);break;
			case('RaceReport'):this.raceReport(set);break;
			case('HighScores'):this.highScores(set);break;
			case('garrage'):this.getGarrage(set);break;
			case('GlobalRank'):this.getGlobalRank(set);break;
			case('RaceHistory'):this.getRaceHistory(set);break;
			default:this.mainMenu(set);break;
		}
		this.status=gameStatus;
	}
	
	this.drawLoading=drawLoading;function drawLoading(count, total){
		var obj;
		if(count===true){
			obj=document.getElementById('loadingContainer');
			if(obj){
				
			}
			obj=document.getElementById('loadingRaceLogo');
			if(obj){
				obj.style.backgroundImage='url('+this.handler.homeURL+'assets/images/translate/'+this.handler.language+'/typing_race.png)';
				obj.style.marginTop=(10*this.scaleVal)+'px';
				obj.style.width=(337*this.scaleVal)+'px';
				obj.style.height=(155*this.scaleVal)+'px';
			}
			obj=document.getElementById('loadingRaceText');
			if(obj){
				obj.style.backgroundImage='url('+this.handler.homeURL+'assets/images/translate/'+this.handler.language+'/Loading_text.png)';
				obj.style.marginTop=(300*this.scaleVal)+'px';
				obj.style.width=(124*this.scaleVal)+'px';
				obj.style.height=(38*this.scaleVal)+'px';
			}
			obj=document.getElementById('loadingBarContainer');
			if(obj){
				obj.style.marginTop=(7*this.scaleVal)+'px';
				obj.style.width=(538*this.scaleVal)+'px';
				obj.style.height=(52*this.scaleVal)+'px';
				obj.style.paddingLeft=(12*this.scaleVal)+'px';
				obj.style.paddingTop=(2*this.scaleVal)+'px';
			}
			obj=document.getElementById('loadingBar');
			if(obj){
				obj.style.backgroundSize=(100/this.LoadingPerc)+'%';
				obj.style.width=(526.5*this.scaleVal*this.LoadingPerc)+'px';
				obj.style.height=(36*this.scaleVal)+'px';
			}
			return;
		}
		this.LoadingPerc=count/total;
		if(this.lastLoadPerc!=this.LoadingPerc){
			obj=document.getElementById('loadingBar');
			if(obj){
				obj.style.height=(36*this.scaleVal)+'px';
				obj.style.width=(526.5*this.scaleVal*this.LoadingPerc)+'px';
				obj.style.backgroundSize=(100/this.LoadingPerc)+'%';
			}
			this.lastLoadPerc=this.LoadingPerc;
		}
	}
	
	this.getButtonCode=getButtonCode;function getButtonCode(id,src,srcH,width,height,callFunc,hoverOn,hoverOff){
		if(!this.handler.assets.Data.Images[src])return('ERROR LOADING IMAGE '+src+' !');
		if(!this.handler.assets.Data.Images[srcH])return('ERROR LOADING IMAGE '+srcH+' !');
		if(!callFunc)callFunc='getButtonCode';
		if(hoverOn)hoverOn='game.UI.'+hoverOn+';';
		if(hoverOff)hoverOff='game.UI.'+hoverOff+';';
		if(width==0)width=parseInt(this.handler.assets.Data.Images[src].width);
		if(height==0)height=parseInt(this.handler.assets.Data.Images[src].height);
		var html='<img id="button_'+id+'" src="'+this.handler.assets.Data.Images[src].src+'" onmouseover="this.src=\''+this.handler.assets.Data.Images[srcH].src+'\';'+hoverOn+'" onmouseout="this.src=\''+this.handler.assets.Data.Images[src].src+'\';'+hoverOff+'" style="border:0px;cursor:pointer;width:'+(width*this.scaleVal)+'px;height:'+(height*this.scaleVal)+'px;" onclick="game.UI.'+callFunc+'();" />';
		return(html);
	}

	this.getPanelCode=getPanelCode;function getPanelCode(id,src,srcH,width,height,left,top,fontFamily,fontSize,txt,callFunc,resizeFont){
		if(!this.handler.assets.Data.Images[src])return('ERROR LOADING IMAGE '+src+' !');
		if(!this.handler.assets.Data.Images[srcH])return('ERROR LOADING IMAGE '+srcH+' !');
		if(width==0)width=parseInt(this.handler.assets.Data.Images[src].width);
		if(height==0)height=parseInt(this.handler.assets.Data.Images[src].height);
		width-=left*2;height-=top;
		width*=this.scaleVal;fontSize*=this.scaleVal;
		var html='<div onmouseover="this.style.backgroundImage=\'url('+this.handler.assets.Data.Images[srcH].src+')\';" onmouseout="this.style.backgroundImage=\'url('+this.handler.assets.Data.Images[src].src+')\';" style="background-image:url(\''+this.handler.assets.Data.Images[src].src+'\');background-size:100% 100%;border:0px;width:'+(width)+'px;height:'+(height*this.scaleVal)+'px;';
		html+='padding-left:'+(left*this.scaleVal)+'px;padding-right:'+(left*this.scaleVal)+'px;padding-top:'+(top*this.scaleVal)+'px;';
		html+='font:'+(fontSize)+'px '+fontFamily+';';
		if(callFunc)html+='cursor:pointer;';
		html+='"';
		if(callFunc)html+='" onclick="game.UI.'+callFunc+'();"';
		html+=' align="center">';
		var i,fsz;
		width*=0.95;
		for(i=0;i<txt.length;i++){
			fsz=fontSize;
			if(resizeFont){
				this.measuringCtx.font=fsz+"px "+fontFamily;
				var w=this.measuringCtx.measureText(txt[i][0]).width;
				while(w>width && fsz>0){
					fsz-=0.1;
					this.measuringCtx.font=fsz+"px "+fontFamily;
					w=this.measuringCtx.measureText(txt[i][0]).width;
				}
			}
			if(!txt[i][1])txt[i][1]=height;
			html+='<span style="font:'+(fsz)+'px '+fontFamily+';"><div style="line-height:'+Math.round(txt[i][1]*this.scaleVal)+'px;vertical-align:middle;"';
			if(txt[i][2])html+=' class="panelHover" onclick="game.UI.'+txt[i][2]+'();"';
			html+='>';
			html+=txt[i][0]+'</div></span>';
		}
		html+='</div>';
		return(html);
	}
	
	this.getTextWidth=getTextWidth;function getTextWidth(txt,fontFamily,fontSize){
		this.measuringCtx.font=fontSize+"px "+fontFamily;
		var w=this.measuringCtx.measureText(txt).width;
		return(w);
	}
	
	this.getTextButtonCode=getTextButtonCode;function getTextButtonCode(text,classN,width,height,font_size,textX,textY,callFunc,idN,skipValign,textWPercent){
		var w=Math.round(width*this.scaleVal);
		var h=Math.round(height*this.scaleVal);
		var fSize=font_size*this.scaleVal;
		var marginW=0;
		if(this.handler.assets.Data.Images['margin'+classN])
			marginW=Math.round(this.handler.assets.Data.Images['margin'+classN].width*height/this.handler.assets.Data.Images['margin'+classN].height*this.scaleVal);
		textX*=this.scaleVal;textY*=this.scaleVal;
		if(textX>0){padding='left';}else{padding='right';textX=-textX;}
		
		if(true){
			if(!textWPercent)textWPercent=0.8;
			var fsz=fSize;
			var wM=(w-2*marginW-textX)*textWPercent;
			this.measuringCtx.font=fsz+"px airstrike";
			var wm=this.measuringCtx.measureText(text).width;
			while(wm>wM && fsz>0){
				fsz-=0.1;
				this.measuringCtx.font=fsz+"px airstrike";
				wm=this.measuringCtx.measureText(text).width;
			}
		}
		
		
		var html='<div class="button_'+classN+'"';
		if(callFunc)html+=' onmouseover="this.className=\'button_'+classN+'On\';" onmouseout="this.className=\'button_'+classN+'\';" ';
		html+=' style="width:'+w+'px;height:'+h+'px;font-size:'+fsz+'px;';
		if(callFunc)html+='cursor:pointer;';else html+='cursor:default;';
		html+='"';
		if(callFunc)html+='" onclick="game.UI.'+callFunc+'();"';
		html+=' align="center">';
		html+='<div style="clear:both"></div>';
		html+='<div class="buttonMargin" style="width:'+marginW+'px;"></div>';
		html+='<div class="buttonMiddle" style="padding-'+padding+':'+textX+'px;width:'+(w-2*marginW-textX)+'px;">';
		if(skipValign)
			html+='<div style="margin-top:'+textY+'px;"';
		else
			html+='<div style="margin-top:'+textY+'px;line-height:'+(h-textY)+'px;"';
		if(idN)html+=' id="'+idN+'"';
		html+='>'+text+'</div></div>';
		html+='<div class="buttonMargin flippedImg" style="width:'+marginW+'px;"></div>';
		html+='<div style="clear:both"></div>';
		html+='</div>';
		return(html);
	}
	
	this.showPopup=showPopup;function showPopup(code,BG,width,height,Dx,Dy){
		var obj,html;
		obj=document.getElementById('popupContainer');
		if(!obj){
			html='<div id="popupContainer" style="position:absolute;background-repeat:no-repeat;background-size:100%;z-index:100;"><div>';
			this.mainDiv.innerHTML+=html;
		}
		obj=document.getElementById('popupContainer');
		if(!BG)BG='PopupBg';
		var img=this.handler.assets.Data.Images[BG];
		if(!width)width=img.width;
		if(!height)height=img.height;
		if(!Dx)Dx=0;if(!Dy)Dy=-35;
		obj.style.backgroundImage="url('"+img.src+"')";
		obj.style.width=(width*this.scaleVal)+'px';
		obj.style.height=(height*this.scaleVal)+'px';
		obj.style.marginLeft=(((960-width)/2+Dx)*this.scaleVal)+'px';
		obj.style.marginTop=(((640-height)/2+Dy)*this.scaleVal)+'px';
		obj.innerHTML=code;
		obj.style.display='block';
		obj.onclick=function(){
			game.UI.mainDiv.onclick='';
			setTimeout(function(){game.UI.mainDiv.onclick=hidePopup;},500);
		}
		game.UI.mainDiv.onclick='';
		setTimeout(function(){game.UI.mainDiv.onclick=hidePopup;},500);
	}
	
	this.hidePopup=hidePopup;function hidePopup(){
		if(game.UI.loginPanelOpen)game.UI.showLogMenu();
		var obj=document.getElementById('popupContainer');
		if(obj)obj.style.display='none';
		game.UI.mainDiv.onclick='';
	}
	
	this.focusInput=focusInput;function focusInput(){
		var obj=document.getElementById('raceInput');
		if(obj)obj.focus();
	}

	this.loginScreen1=loginScreen1;function loginScreen1(set){
		var html,obj;
		if(set){
			if(this.handler.GSPStart){
				obj=document.getElementById('loginButtonContainer');
				if(obj)obj.style.display='block';
			}
		}else{
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.LoginBackground.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			html='<div style="position:absolute;margin-top:'+(300*this.scaleVal)+'px;margin-left:'+(367*this.scaleVal)+'px;" id="loginButtonContainer">'+this.getTextButtonCode(this.handler.config.menuTexts.Login,'52',226,52,32,0,0,'loginButtonPress')+'</div>';
			html+='<div style="position:absolute;margin-top:'+(387*this.scaleVal)+'px;margin-left:'+(367*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Guest,'52',226,52,32,0,0,'guestButtonPress')+'</div>';
			this.mainDiv.innerHTML=html;
		}
	}

	this.loginScreen2=loginScreen2;function loginScreen2(set){
		if(set){
		}else{
			var html='',providers,i;
			this.mainDiv.style.backgroundImage="none";
			if(GSP && this.handler.GSPStart)providers=GSP.getSocialProviders();else providers=new Array();
			if(!providers)providers=new Array();
			html+='<div align="center" style="position:absolute;margin-top:'+(50*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;"><div style="position:relative;width:'+(337*this.scaleVal)+'px;height:'+(155*this.scaleVal)+'px;background-image:url('+this.handler.homeURL+'assets/images/translate/'+this.handler.language+'/typing_race.png);background-size:100%;" align="center"></div></div>';
			html+='<div align="center" style="position:absolute;margin-top:'+(320*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;">';
			for(i=0;i<providers.length;i++){
				html+='<span style="padding:'+(30*this.scaleVal)+'px;">'+this.getButtonCode(providers[i],providers[i]+'H',providers[i]+'H',0,0,'Login(\''+providers[i]+'\');console.log','providerOn('+i+')','providerOff('+i+')')+'</span>';
			}
			html+='</div>';
			html+='<div style="position:absolute;margin-top:'+(550*this.scaleVal)+'px;margin-left:'+(750*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Back,'64',140,45,24,0,0,'mainMenuButtPress')+'</div>';
//			html+='<div style="position:relative;padding-top:'+(300*this.scaleVal)+'px;width:100%;">'+this.getButtonCode('LoginButton','LoginButton','LoginButtonH',0,0,'loginButtonPress')+'</div>';
//			html+='<div style="position:relative;padding-top:'+(30*this.scaleVal)+'px;width:100%;">'+this.getButtonCode('GuestButton','GuestButton','GuestButtonH',228,68,'guestButtonPress')+'</div>';
			this.mainDiv.innerHTML=html;
		}
	}
	this.providerOn=providerOn;function providerOn(id){
		var providers,i,obj;
		if(GSP && this.handler.GSPStart)providers=GSP.getSocialProviders();else providers=new Array();
		if(!providers)providers=new Array();
		for(i=0;i<providers.length;i++){
			obj=document.getElementById('button_'+providers[i]);
			if(!obj)continue;
			if(id!=i)obj.src=this.handler.assets.Data.Images[providers[i]].src;
		}
	}
	
	this.providerOff=providerOff;function providerOff(id){
		var providers,i,obj;
		if(GSP && this.handler.GSPStart)providers=GSP.getSocialProviders();else providers=new Array();
		if(!providers)providers=new Array();
		for(i=0;i<providers.length;i++){
			obj=document.getElementById('button_'+providers[i]);
			if(!obj)continue;
			if(id!=i)obj.src=this.handler.assets.Data.Images[providers[i]+'H'].src;
		}
	}
	
	this.Login=Login;function Login(provider){
		login(provider);
	}

	this.loginButtonPress=loginButtonPress;function loginButtonPress(){
		setCookie('typingRaceSkipAdd','skip',10000);
		if(!GSP || !this.handler.GSPStart)return;
		this.handler.status='login screen 2';
	}
	
	this.guestButtonPress=guestButtonPress;function guestButtonPress(){
		this.handler.player={
			info:{
				name:'Guest'
			},
			carType:0
		}
		this.handler.status='main menu set';
	}
	
	this.mainMenu=mainMenu;function mainMenu(set){
		if(this.handler.loadingStage<1)return;
		if(!this.handler.player){this.loginScreen1(set);return;}
		if(set){
		}else{
			
		var LevelConfig=this.handler.assets.Data.Files.LevelConfig;
		if(!LevelConfig){console.log('no levelConfig data');return null;}
			
			var html='';
			html+='<div id="mainMenuTopBar">';//getPanelCode(id,src,srcH,width,height,left,top,fontFamily,fontSize,txt,callFunc,resizeFont)
			html+='<div style="float:left;padding-left:'+(40*this.scaleVal)+'px;padding-top:'+(6*this.scaleVal)+'px;" id="playerNameContainer">';
			if(GSP && GSP.isInitiated() && !GSP.isPlayerLogin())
				html+=this.getPanelCode('playerName','EmptyButton','EmptyButton',0,0,20,0,'airstrike',24,[[this.handler.config.menuTexts.Login,0]],'loginButtonPress',true);
			else if(GSP && GSP.isInitiated())
				html+=this.getPanelCode('playerName','EmptyButton','EmptyButton',0,0,20,0,'airstrike',24,[[this.handler.player.info.name,0]],'showLogMenu',true);
			else
				html+=this.getPanelCode('playerName','EmptyButton','EmptyButton',0,0,20,0,'airstrike',24,[[this.handler.player.info.name,0]],'loginButtonPress',true);
			html+='</div>';
			var languageButt;
			if(this.handler.config.gameSettings.language.skipFlag)languageButt=this.handler.config.gameSettings.language.text;
			else languageButt='<img align="absmiddle" width="'+(46*this.scaleVal)+'" height="'+(29*this.scaleVal)+'" src="'+this.handler.assets.Data.Images.flag.src+'" style="padding-right:'+(10*this.scaleVal)+'px;" />'+this.handler.config.gameSettings.language.text
			html+='<div style="float:left;padding-left:'+(80*this.scaleVal)+'px;padding-top:'+(7*this.scaleVal)+'px;">'+this.getTextButtonCode(languageButt,'65',150,42,30,0,0,'languageSelect',false,false,999.0)+'</div>';
			if(this.handler.soundOn)
				html+='<div style="float:left;padding-left:'+(80*this.scaleVal)+'px;padding-top:'+(8*this.scaleVal)+'px;" id="soundSettingsContainer">'+this.getButtonCode('SoundButton','soundON','soundON',0,0,'soundButtonPress')+'</div>';
			else
				html+='<div style="float:left;padding-left:'+(80*this.scaleVal)+'px;padding-top:'+(8*this.scaleVal)+'px;" id="soundSettingsContainer">'+this.getButtonCode('SoundButton','soundOFF','soundOFF',0,0,'soundButtonPress')+'</div>';
			html+='</div>';
			html+='<div style="position:absolute;margin-top:'+(82*this.scaleVal)+'px;margin-left:'+(365*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.GoToGarage,'gotogarage',437,286,22,-110,53,'garrageButtonPress',false,true,0.44)+'</div>';
			html+='<div id="mainMenuBottomBar" style="margin-top:'+(400*this.scaleVal)+'px;z-index:101;">';
			html+='<div style="float:left;padding-left:'+(20*this.scaleVal)+'px;padding-top:'+(10*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Multiplayer,'multiplayer',311,193,31,7,45,'multiButtonPress',false,false,0.6)+'</div>';
			html+='<div style="float:left;padding-left:'+(20*this.scaleVal)+'px;padding-top:'+(10*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.SoloRace,'solorace',288,195,31,7,44,'soloButtonPress',false,false,0.6)+'</div>';
			html+='<div style="float:left;padding-left:'+(20*this.scaleVal)+'px;padding-top:'+(3*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.highScore,'highScore',264,188,30,-14,63,'highScoresButtonPress',false,false,0.6)+'</div>';
			html+='</div>';
			html+='<div id="statusBarMainMenu" style="width:'+(960*this.scaleVal)+'px;height:'+(45*this.scaleVal)+'px;margin-top:'+(591*this.scaleVal)+'px;font:'+(24*this.scaleVal)+'px airstrike;">';
			html+='<div style="float:left;margin-left:'+(40*this.scaleVal)+'px;margin-top:'+(9*this.scaleVal)+'px;"><img src="'+this.handler.assets.Data.Images.PlayerIcon.src+'" width="'+(24*this.scaleVal)+'" height="'+(32*this.scaleVal)+'" /></div>';
			html+='<div style="float:left;margin-left:'+(5*this.scaleVal)+'px;line-height:'+(45*this.scaleVal)+'px;"><span style="color:#fff200" id="onlinePlayers"></span>&nbsp;'+this.handler.config.menuTexts.onlinePlayers+'</div>';
			html+='<div style="float:left;margin-left:'+(400*this.scaleVal)+'px;margin-top:'+(9*this.scaleVal)+'px;"><img src="'+this.handler.assets.Data.Images.GamesIcon.src+'" width="'+(29*this.scaleVal)+'" height="'+(28*this.scaleVal)+'" /></div>';
			html+='<div style="float:left;margin-left:'+(5*this.scaleVal)+'px;line-height:'+(45*this.scaleVal)+'px;width:'+(230*this.scaleVal)+'px;" align="left"><span style="color:#fff200" id="activeGames"></span>&nbsp;'+this.handler.config.menuTexts.gamesPlayed+'</div>';
			html+='</div>';
			//this.handler.assets.Data.Images.emptyBG.src
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.MainMenuBg.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			this.loginPanelOpen=false;
			this.mainDiv.innerHTML=html;
		}
	}
	
	this.showLogMenu=showLogMenu;function showLogMenu(){
		var obj=document.getElementById('playerNameContainer');
		if(!obj)return;
		var html;
		if(this.loginPanelOpen)html=this.getPanelCode('playerName','EmptyButton','EmptyButton',0,0,20,0,'airstrike',24,[[this.handler.player.info.name,0]],'showLogMenu',true);
		else{
			setTimeout(function(){game.UI.mainDiv.onclick=hidePopup;},500);
			if(GSP.isPlayerLogin())
				html=this.getPanelCode('playerName','EmptyButtonH','EmptyButtonH',0,0,20,0,'airstrike',24,[[this.handler.player.info.name,45,'showLogMenu'],[this.handler.config.menuTexts.Logout,42,'logOut']],false,true,this.handler.config.menuTexts.Logout);
			else
				html=this.getPanelCode('playerName','EmptyButtonH','EmptyButtonH',0,0,20,0,'airstrike',24,[[this.handler.player.info.name,45,'showLogMenu'],[this.handler.config.menuTexts.Login,42,'loginButtonPress']],false,true,this.handler.config.menuTexts.Login);
		}
		this.loginPanelOpen=!this.loginPanelOpen;
		obj.innerHTML=html;
	}
	
	this.logOut=logOut;function logOut(){
		setCookie('typingRaceSkipAdd','skip',10000);
		this.loginPanelOpen=false;
		console.log('logging out');
		GSP.logout(function(){clearGet();});
	}
	
	this.soundButtonPress=soundButtonPress;function soundButtonPress(ignoreButton,stopSentence){
		this.focusInput();
		var obj=document.getElementById('soundSettingsContainer');
		if(!obj && !ignoreButton)return;
		if(this.handler.soundOn){
			this.handler.soundOn=false;
			if(this.handler.assets.Data.Sounds.raceMusic && this.handler.assets.Data.Sounds.raceMusic.playing)this.handler.assets.Data.Sounds.raceMusic.Stop();
			if(this.handler.assets.Data.Sounds.RedLight && this.handler.assets.Data.Sounds.RedLight.playing)this.handler.assets.Data.Sounds.RedLight.Stop();
			if(this.handler.assets.Data.Sounds.YellowLight && this.handler.assets.Data.Sounds.YellowLight.playing)this.handler.assets.Data.Sounds.YellowLight.Stop();
			if(this.handler.assets.Data.Sounds.GreenLight && this.handler.assets.Data.Sounds.GreenLight.playing)this.handler.assets.Data.Sounds.GreenLight.Stop();
			if(this.handler.assets.Data.Sounds.typo && this.handler.assets.Data.Sounds.typo.playing)this.handler.assets.Data.Sounds.typo.Stop();
			if(this.handler.assets.Data.Sounds.engine1 && this.handler.assets.Data.Sounds.engine1.playing)this.handler.assets.Data.Sounds.engine1.Stop();
			if(this.handler.assets.Data.Sounds.engine2 && this.handler.assets.Data.Sounds.engine2.playing)this.handler.assets.Data.Sounds.engine2.Stop();
			if(this.handler.assets.Data.Sounds.crash && this.handler.assets.Data.Sounds.crash.playing)this.handler.assets.Data.Sounds.crash.Stop();
			if(this.handler.assets.Data.Sounds.cheer && this.handler.assets.Data.Sounds.cheer.playing)this.handler.assets.Data.Sounds.cheer.Stop();
			if(obj)obj.innerHTML=this.getButtonCode('SoundButton','soundOFF','soundOFF',0,0,'soundButtonPress');
			if(this.handler.sentenceAudio && stopSentence)this.handler.sentenceAudio.Stop();
		}else{
			this.handler.soundOn=true;
			if(this.handler.assets.Data.Sounds.raceMusic && this.status!='main menu'){
				this.handler.assets.Data.Sounds.raceMusic.sound.loop=true;
				this.handler.assets.Data.Sounds.raceMusic.Play();
			}
			if(obj)obj.innerHTML=this.getButtonCode('SoundButton','soundON','soundON',0,0,'soundButtonPress');
		}
	}
	
	this.languageSelect=languageSelect;function languageSelect(){
		var html,i,lang=this.handler.config.gameSettings.language.list;
		html='<table cellpadding="0" cellspacing="'+(10*this.scaleVal)+'" border="0" style="margin-left:'+(17*this.scaleVal)+'px;margin-top:'+(50*this.scaleVal)+'px;"><tr>';
		var languageButt;
		for(i=0;i<lang.length;i++){
			if(lang[i].skipFlag)languageButt=lang[i].text;
			else languageButt='<img align="absmiddle" width="'+(46*this.scaleVal)+'" height="'+(29*this.scaleVal)+'" src="'+this.handler.assets.Data.Images['flag_'+i].src+'" style="padding-right:'+(10*this.scaleVal)+'px;" />'+lang[i].text;
			html+='<td>'+this.getTextButtonCode(languageButt,'65',150,42,30,0,0,'emptyFunc();game.language=\''+lang[i].folder+'\';game.UI.languageChange',false,false,999.0)+'</td>';
			if(i<lang.length-1 && i%2)html+='</tr><tr>';
		}
		html+='</tr></table>';
		this.showPopup(html,'LangPopup',0,0,-40,-50);
	}
	
	this.emptyFunc=emptyFunc;function emptyFunc(){}
	
	this.languageChange=languageChange;function languageChange(){
		setCookie('typingRaceSkipAdd','skip',10000);
		this.handler.loadingStage=0;
		this.handler.Load(true);
	}
	
	this.highScoresButtonPress=highScoresButtonPress;function highScoresButtonPress(){
		if(!GSP || !this.handler.GSPStart)return;
		this.handler.status='waiting';
		this.getHighScores('DAILY','SCORE');
	}
	
	this.garrageButtonPress=garrageButtonPress;function garrageButtonPress(){
		if(!GSP)return;
		if(GSP.isPlayerLogin()){
			this.handler.status='waiting';
			GSP.getPlayerBestScores({},function(status, data){
				game.player.points=parseInt(data.points);
				game.player.rank=parseInt(data.rank);
				game.player.highScore=parseInt(data.score);
				game.gameOver('LoadGarrage');
			});
		}else{
			this.handler.gameOver('LoadGarrage');
		}
	}
	
	this.difficultySelect=difficultySelect;function difficultySelect(){
		var html;
		var sz=34;
		html='<div align="center" style="color:#fff;padding-left:'+(2*this.scaleVal)+'px;height:'+(50*this.scaleVal)+'px;margin-top:'+(30*this.scaleVal)+'px;font:'+(sz*this.scaleVal)+'px airstrike;">'+this.handler.config.menuTexts.Difficulty+'</div>';
		html+='<div align="center" style="color:#000;margin-top:-'+(51*this.scaleVal)+'px;font:'+(sz*this.scaleVal)+'px airstrike;">'+this.handler.config.menuTexts.Difficulty+'</div>';
		html+='<div align="center" style="margin-top:'+(20*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Easy,'65',205,60,30,0,0,'startEasy')+'</div>';
		html+='<div align="center" style="margin-top:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Medium,'65',205,60,30,0,0,'startMedium')+'</div>';
		html+='<div align="center" style="margin-top:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Hard,'65',205,60,30,0,0,'startHard')+'</div>';
		this.showPopup(html);
	}
	
	this.startEasy=startEasy;function startEasy(){
		this.handler.difficulty=0;
		console.log('starting easy game');
		this.handler.startGame();
	}
	
	this.startMedium=startMedium;function startMedium(){
		this.handler.difficulty=1;
		console.log('starting medium game');
		this.handler.startGame();
	}
	
	this.startHard=startHard;function startHard(){
		this.handler.difficulty=2;
		console.log('starting hard game');
		this.handler.startGame();
	}
	
	this.soloButtonPress=soloButtonPress;function soloButtonPress(){
		this.handler.gameType='single';
		this.handler.cars=false;
		this.difficultySelect();
	}
	
	this.multiButtonPress=multiButtonPress;function multiButtonPress(){
		if(!GSP)return;
		if(!GSP.isInitiated())return;
//		if(!GSP.multiplayer.isConnected())return;
		console.log('starting multiplayer game');
		this.handler.gameType='multi';
		this.handler.cars=false;
		this.handler.difficulty=3;
		this.handler.startGame();
	}

	this.race=race;function race(set){
		var i;
		if(set){
			var obj;
			if(!this.raceCtx)return;
//			this.mainDiv.style.backgroundPosition='-'+parseInt(this.handler.trackPan*this.scaleVal)+'px 0px';
			this.mainDiv.style.backgroundPosition='-'+parseInt(this.handler.trackPos*this.scaleVal)+'px 0px';
			this.raceCtx.clearRect(0,0,parseInt(960*this.scaleVal),parseInt(640*this.scaleVal));
//			this.raceCtx.fillRect(0,parseInt(960*this.scaleVal),parseInt(256*this.scaleVal),parseInt(600*this.scaleVal));
			if(295-this.handler.trackPos>0){//start line
				this.raceCtx.drawImage(this.handler.assets.Data.Images.Start,(200-this.handler.trackPos)*this.scaleVal,286*this.scaleVal,95*this.scaleVal,290*this.scaleVal);
			}
			if(this.handler.endPos){//finish line
				this.raceCtx.drawImage(this.handler.assets.Data.Images.Finish,(960+this.handler.endPos-this.handler.trackPos)*this.scaleVal,286*this.scaleVal,95*this.scaleVal,290*this.scaleVal);
			}
/*			if(this.handler.trackPan>this.handler.trackLength-900){//finish line
				this.raceCtx.drawImage(this.handler.assets.Data.Images.Finish,(160+this.handler.trackLength-this.handler.trackPan)*this.scaleVal,286*this.scaleVal,95*this.scaleVal,290*this.scaleVal);
			}*/
			//cars
			for(i=0;i<this.handler.cars.length;i++){
				this.handler.SFX.Run(i);
				this.handler.cars[i].Draw();
			}
			if(this.status=='lobby'){
				this.raceCtx.fillStyle="rgba(255,255,255,0.39)";
				this.raceCtx.fillRect(0,0,parseInt(960*this.scaleVal),parseInt(576*this.scaleVal));
			}
			//switchlighr
			var h=0,stage;
			if(this.status=='redlight' || this.status=='lobby'){
				stage=(this.handler.time-this.handler.raceTime)/(this.handler.config.gameSettings.settings.lightTimer/2);
				h=this.handler.assets.Data.Images.RedLight.height*stage-this.handler.assets.Data.Images.RedLight.height;
				if(this.status=='redlight'){
					obj=document.getElementById('waitingContainer');if(obj)obj.style.display='none';
					obj=document.getElementById('waitingText');if(obj)obj.style.display='none';
					obj=document.getElementById('inputHint');if(obj)obj.style.display='none';
					h=0;
				}
				if(h>0)h=0;
				this.raceCtx.drawImage(this.handler.assets.Data.Images.RedLight,600*this.scaleVal,h*this.scaleVal,this.handler.assets.Data.Images.RedLight.width*this.scaleVal,this.handler.assets.Data.Images.RedLight.height*this.scaleVal);
			}else
			if(this.status=='yellowlight'){
				obj=document.getElementById('waitingContainer');if(obj)obj.style.display='none';
				obj=document.getElementById('waitingText');if(obj)obj.style.display='none';
				obj=document.getElementById('inputHint');if(obj)obj.style.display='none';
				this.raceCtx.drawImage(this.handler.assets.Data.Images.YellowLight,600*this.scaleVal,0,this.handler.assets.Data.Images.RedLight.width*this.scaleVal,this.handler.assets.Data.Images.YellowLight.height*this.scaleVal);
			}else
			if(this.status=='greenlight'){
				obj=document.getElementById('waitingContainer');if(obj)obj.style.display='none';
				obj=document.getElementById('waitingText');if(obj)obj.style.display='none';
				obj=document.getElementById('inputHint');if(obj)obj.style.display='none';
				stage=(this.handler.time-this.handler.raceTime)/(this.handler.config.gameSettings.settings.lightTimer/2);
				h=this.handler.assets.Data.Images.RedLight.height-this.handler.assets.Data.Images.RedLight.height*stage;
				if(h>0)h=0;
				this.raceCtx.drawImage(this.handler.assets.Data.Images.GreenLight,600*this.scaleVal,h*this.scaleVal,this.handler.assets.Data.Images.RedLight.width*this.scaleVal,this.handler.assets.Data.Images.GreenLight.height*this.scaleVal);
			}else
			if(this.status=='playing'){
				obj=document.getElementById('waitingContainer');if(obj)obj.style.display='none';
				obj=document.getElementById('waitingText');if(obj)obj.style.display='none';
				obj=document.getElementById('inputHint');if(obj)obj.style.display='none';
			}
			//WPM clock
			var scaleClocks=1.0,angle;
			var count=this.handler.cars[this.handler.player.carID].WPM;
			angle=0.75*Math.PI+count*0.0078*Math.PI;
			this.angle+=0.05;
			this.raceCtx.drawImage(this.handler.assets.Data.Images.WPMclock,843*this.scaleVal,520*this.scaleVal,this.handler.assets.Data.Images.WPMclock.width*this.scaleVal*scaleClocks,this.handler.assets.Data.Images.WPMclock.height*this.scaleVal*scaleClocks);
			drawRotPic(this.handler.assets.Data.Images.WPMdial,895,571,scaleClocks,angle,7.8,8.7,this.raceCtx,this.scaleVal);
			//ERR clock
			count=this.handler.cars[this.handler.player.carID].ERR;
			angle=(0.5+1.5*(count/this.handler.config.gameSettings.difficulty[this.handler.difficulty].errorsToCrash))*Math.PI;
			this.raceCtx.drawImage(this.handler.assets.Data.Images.ErrorClock,740*this.scaleVal,540*this.scaleVal,this.handler.assets.Data.Images.ErrorClock.width*this.scaleVal*scaleClocks,this.handler.assets.Data.Images.ErrorClock.height*this.scaleVal*scaleClocks);
			drawRotPic(this.handler.assets.Data.Images.ErrorDial,784,583,scaleClocks,angle,6.5,7.1,this.raceCtx,this.scaleVal);
			//Acc display
			obj=document.getElementById('ACCBox');
			if(obj){
				if(this.handler.cars[this.handler.player.carID].ERR>this.handler.cars[this.handler.player.carID].position)
					obj.innerHTML='0%';
				else if(this.handler.cars[this.handler.player.carID].position>0)
					obj.innerHTML=Math.round(100-(this.handler.cars[this.handler.player.carID].ERR*100/this.handler.cars[this.handler.player.carID].position))+'%';
				else
					obj.innerHTML='100%';
			}
			//time display
			if(this.status=='greenlight' || this.status=='playing'){
				var time=this.handler.time-this.handler.raceTime;
				var hours=Math.floor(time/3600000);
				time-=hours*3600000;
				if(hours<=9)hours='0'+hours;else hours=hours+' ';
				var minutes=Math.floor(time/60000);
				if(minutes<=9)minutes='0'+minutes;else minutes=minutes+' ';
				time-=minutes*60000;
				var seconds=Math.floor(time/1000);
				if(seconds<=9)seconds='0'+seconds;else seconds=seconds+' ';
				obj=document.getElementById('hour1');if(obj)obj.innerHTML=hours[0];
				obj=document.getElementById('hour2');if(obj)obj.innerHTML=hours[1];
				obj=document.getElementById('min1');if(obj)obj.innerHTML=minutes[0];
				obj=document.getElementById('min2');if(obj)obj.innerHTML=minutes[1];
				obj=document.getElementById('sec1');if(obj)obj.innerHTML=seconds[0];
				obj=document.getElementById('sec2');if(obj)obj.innerHTML=seconds[1];
			}
			if(this.showHint && this.handler.time>this.handler.hintStart+this.handler.config.gameSettings.settings.hintDuration){
				this.showHint=false;
				this.setSentence('Arial',26);
			}
		}else{
			var html='';
			
			html+='<div id="statusBarRace" style="z-index:4;width:'+(960*this.scaleVal)+'px;height:'+(45*this.scaleVal)+'px;margin-top:'+(0*this.scaleVal)+'px;font:'+(24*this.scaleVal)+'px airstrike;" onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()">';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="float:left;margin-left:'+(40*this.scaleVal)+'px;margin-top:'+(9*this.scaleVal)+'px;"><img src="'+this.handler.assets.Data.Images.PlayerIcon.src+'" width="'+(24*this.scaleVal)+'" height="'+(32*this.scaleVal)+'" /></div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="float:left;margin-left:'+(5*this.scaleVal)+'px;line-height:'+(45*this.scaleVal)+'px;"><span style="color:#fff200" id="onlinePlayers"></span>&nbsp;'+this.handler.config.menuTexts.onlinePlayers+'</div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="float:left;margin-left:'+(290*this.scaleVal)+'px;margin-top:'+(9*this.scaleVal)+'px;"><img src="'+this.handler.assets.Data.Images.GamesIcon.src+'" width="'+(29*this.scaleVal)+'" height="'+(28*this.scaleVal)+'" /></div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="float:left;margin-left:'+(5*this.scaleVal)+'px;line-height:'+(45*this.scaleVal)+'px;width:'+(230*this.scaleVal)+'px;" align="left"><span style="color:#fff200" id="activeGames"></span>&nbsp;'+this.handler.config.menuTexts.onlinePlayers+'</div>';
			html+='</div>';
			
			html+='<div id="quitButtonContainer" style="position:absolute;z-index:5;margin-left:'+(860*this.scaleVal)+'px;margin-top:'+(7*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.quit,'64',90,30,18,0,0,'mainMenuButtPress')+'</div>';;
			
			html+='<div style="position:absolute;margin-left:0px;margin-top:0px;z-index:5;"><canvas onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="raceCanvas" width="'+(960*this.scaleVal)+'" height="'+(640*this.scaleVal)+'"></canvas></div>';
			
			//lobby texts & hints
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="waitingContainer" style="position:absolute;color:#000;opacity:1.0;margin-top:'+(90*this.scaleVal)+'px;margin-left:'+(50*this.scaleVal)+'px;font:'+(50*this.scaleVal)+'px airstrike;width:'+(540*this.scaleVal)+'px;height:'+(100*this.scaleVal)+'px;z-index:16;background:none;" align="left">'+this.handler.config.menuTexts.lobbyHint1+'</div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="waitingText" style="position:absolute;color:#eee;text-shadow: '+(3*this.scaleVal)+'px '+(2*this.scaleVal)+'px #000;opacity:1.0;margin-top:'+(330*this.scaleVal)+'px;margin-left:0px;font:'+(50*this.scaleVal)+'px airstrike;width:'+(920*this.scaleVal)+'px;height:'+(54*this.scaleVal)+'px;background-image:url(\''+this.handler.assets.Data.Images.ActionBar.src+'\');background-size:100% 100%;padding-top:'+(10*this.scaleVal)+'px;padding-left:'+(40*this.scaleVal)+'px;z-index:16;" align="left">'+this.handler.config.menuTexts.waiting+'</div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="inputHint" style="position:absolute;margin-left:'+(40*this.scaleVal)+'px;margin-top:'+(535*this.scaleVal)+'px;padding:'+(5*this.scaleVal)+'px;width:'+(666*this.scaleVal)+'px;height:'+(32*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.TypingFrame.src+'\');z-index:16;font:'+(32*this.scaleVal)+'px airstrike;color:#f00;" align="center"><div style="padding-top:'+(3*this.scaleVal)+'px;">'+this.handler.config.menuTexts.lobbyHint2+'</div></div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="noTypeHint" style="position:absolute;display:none;margin-left:'+(269*this.scaleVal)+'px;margin-top:'+(350*this.scaleVal)+'px;width:'+(this.handler.assets.Data.Images.bigToolTip.width*this.scaleVal)+'px;height:'+(this.handler.assets.Data.Images.bigToolTip.height*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.TypingFrame.src+'\');z-index:16;font:'+(34*this.scaleVal)+'px airstrike;color:#f00;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.bigToolTip.src+'\');" align="center"><div style="vertical-align:middle;padding:'+(50*this.scaleVal)+'px;padding-top:'+(30*this.scaleVal)+'px;">'+this.handler.config.menuTexts.raceHint1+'</div></div>';
			
			for(i=0;i<5;i++){
				html+='<div style="color:#fff;position:absolute;z-index:15;margin-left:'+(5*this.scaleVal)+'px;margin-top:'+((300+i*52)*this.scaleVal)+'px;font:'+(15*this.scaleVal)+'px Arial;" id="laneName'+i+'">';
				
				if(this.handler.cars[i])
					if(this.handler.cars[i].type=='PC' && (!GSP || !GSP.isPlayerLogin()))html+=this.handler.config.menuTexts.Me;
					else html+=this.handler.cars[i].name;
				html+='</div>';
			}
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="TimeBox" style="position:absolute;color:#fff;margin-left:'+(540*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;z-index:12;padding-top:'+(3*this.scaleVal)+'px;padding-left:'+(0*this.scaleVal)+'px;width:'+(171*this.scaleVal)+'px;height:'+(33*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.Time.src+'\');font:'+(24*this.scaleVal)+'px Arial;" align="left"><table cellspacing="0" cellpadding="'+(3*this.scaleVal)+'" border="0"><tr><td style="padding-left:'+(19*this.scaleVal)+'px;" id="hour1">0</td><td id="hour2">0</td><td style="padding-left:'+(15*this.scaleVal)+'px;" id="min1">0</td><td id="min2">0</td><td style="padding-left:'+(16*this.scaleVal)+'px;" id="sec1">0</td><td id="sec2">0</td></tr></table></div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="position:absolute;margin-left:'+(340*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;z-index:12;padding-top:'+(3*this.scaleVal)+'px;padding-left:'+(90*this.scaleVal)+'px;width:'+(81*this.scaleVal)+'px;height:'+(33*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.ACC.src+'\');font:'+(24*this.scaleVal)+'px Arial;" align="left"><div style="font:'+(26*this.scaleVal)+'px Arial;color:#fff200;margin-left:-'+(80*this.scaleVal)+'px;float:left;">'+this.handler.config.menuTexts.ACC+'.</div><div style="float:left;" id="ACCBox">100%</div></div>';
			html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="position:absolute;margin-left:'+(40*this.scaleVal)+'px;margin-top:'+(535*this.scaleVal)+'px;z-index:12;padding:'+(5*this.scaleVal)+'px;width:'+(666*this.scaleVal)+'px;height:'+(32*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.TypingFrame.src+'\');" align="left"><div id="typingArea" style="position:absolute;overflow:hidden;width:'+(656*this.scaleVal)+'px;margin-left:'+(5*this.scaleVal)+'px;"><div style="height:'+(32*this.scaleVal)+'px;" id="typingInnerArea"></div></div></div>';
			
				//hints
				html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="HintsBoxContainer" style="position:absolute;margin-left:'+(140*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;z-index:17;padding-top:'+(4*this.scaleVal)+'px;padding-left:'+(90*this.scaleVal)+'px;width:'+(81*this.scaleVal)+'px;height:'+(33*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.HintBG.src+'\');font:'+(24*this.scaleVal)+'px Arial;" align="left"><div style="font:'+(26*this.scaleVal)+'px Arial;color:#fff200;margin-left:-'+(80*this.scaleVal)+'px;float:left;">'+this.handler.config.menuTexts.HINTS+'</div><div style="float:left;width:'+75*this.scaleVal+'px;padding-top:'+(2*this.scaleVal)+'px;" id="HintsBox" align="center"></div></div>';
				//hints button
				html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="hintButtonContainer" style="position:absolute;margin-left:'+(20*this.scaleVal)+'px;margin-top:'+(531*this.scaleVal)+'px;z-index:17;padding-top:'+(4*this.scaleVal)+'px;">'+this.getButtonCode('hintButton','hintButton','hintButton',0,0,'hintButtonPress')+'</div>';
				//replay button
				html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" id="replayButtonContainer" style="position:absolute;margin-left:'+(20*this.scaleVal)+'px;margin-top:'+(587*this.scaleVal)+'px;z-index:17;padding-top:'+(4*this.scaleVal)+'px;">'+this.getButtonCode('replayButton','replay','replay',0,0,'replayButtonPress')+'</div>';
			
			if(this.handler.soundOn)
				html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="position:absolute;z-index:16;margin-left:'+(75*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;" id="soundSettingsContainer">'+this.getButtonCode('SoundButton','soundON','soundON',0,0,'soundButtonPress')+'</div>';
			else
				html+='<div onclick="game.UI.focusInput()"  onfocus="game.UI.focusInput()" style="position:absolute;z-index:16;margin-left:'+(75*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;" id="soundSettingsContainer">'+this.getButtonCode('SoundButton','soundOFF','soundOFF',0,0,'soundButtonPress')+'</div>';

			html+='<div style="raceInputContainer"><input type="text" id="raceInput" onkeyup="game.keyPressed();" /></div>';
			
			this.mainDiv.innerHTML=html;
			this.setSentence('Arial',26);
			this.showHints();
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.raceBG.src+"')";
			this.mainDiv.style.backgroundPosition='0px 0px';
			this.raceCtx=document.getElementById('raceCanvas').getContext("2d");
			this.mainDiv.onclick=this.focusInput;
			this.focusInput();
			var obj=document.getElementById('raceInput');
			if(obj)obj.lastSize=0;
			if(this.handler.SFX)this.handler.SFX.effects=new Array();
		}
	}
	
	this.hintButtonPress=hintButtonPress;function hintButtonPress(){
		if(this.handler.status!='playing')return;
		this.focusInput();
		if(this.handler.hints<=0)return;
		this.handler.hints--;
		this.showHints();
		this.handler.hintStart=this.handler.time;
		this.showHint=true;
		this.setSentence('Arial',26);
		this.showHints();
	}
	
	this.showHints=showHints;function showHints(){
		var obj=document.getElementById('HintsBox');
		if(!obj)return;
		var i,html='';
		var img=this.handler.assets.Data.Images.hintIcon;
		for(i=0;i<this.handler.hints;i++){
			html+='<img src="'+img.src+'" width="'+(img.width*this.scaleVal)+'px" height="'+(img.height*this.scaleVal)+'px" style="padding-left:'+(2*this.scaleVal)+'px;" />';
		}
		obj.innerHTML=html;
		if(this.handler.hints<=0 || !this.handler.sentenceAudio){
			obj=document.getElementById('HintsBoxContainer');
			if(obj)obj.style.display='none';
			obj=document.getElementById('hintButtonContainer');
			if(obj)obj.style.display='none';
		}else{
			obj=document.getElementById('HintsBoxContainer');
			if(obj)obj.style.display='block';
			obj=document.getElementById('hintButtonContainer');
			if(obj)obj.style.display='block';
		}
	}
	
	this.replayButtonPress=replayButtonPress;function replayButtonPress(){
		this.handler.playSentenceAudio=true;
		this.focusInput();
	}
	
	this.setSentence=setSentence;function setSentence(fontFamily,fontSize){
		var obj=document.getElementById('typingInnerArea');
		if(!obj)return;
		if(this.handler.currentSentence<this.handler.sentences.length-1){
			if(this.handler.currentLetter>=this.handler.sentences[this.handler.currentSentence+1].start){
				this.handler.setCurrentSentence(this.handler.currentSentence+1);
				this.showHints();
			}
		}
		fontSize*=this.scaleVal;
		obj.style.font=fontSize+"px "+fontFamily;
		this.measuringCtx.font=fontSize+"px "+fontFamily;
		var txt,w;
		if(this.handler.sentenceAudio && !this.showHint){
			txt=this.handler.sentences[this.handler.currentSentence].text.substring(0,this.handler.currentLetter-this.handler.sentences[this.handler.currentSentence].start)+'_';
			w=this.measuringCtx.measureText(this.handler.sentences[this.handler.currentSentence].text+'_').width;
		}else{
			txt=this.handler.getHtmlSentence();
			w=this.measuringCtx.measureText(this.handler.sentences[this.handler.currentSentence].text+'_').width;
		}
		
		if(this.handler.config.gameSettings.language.rtl){
			obj.style.direction='rtl';
			obj.style.unicodeBidi = "bidi-override";
		}else{
			obj.style.direction='ltr';
			obj.style.unicodeBidi = "bidi-override";
		}

		obj.style.width=w+'px';
		obj.innerHTML=txt;
		obj=document.getElementById('typingArea');
		if(!obj)return;
		var left=this.handler.sentences[this.handler.currentSentence].text.substring(0,this.handler.currentLetter-this.handler.sentences[this.handler.currentSentence].start);
		left=this.measuringCtx.measureText(left).width;
		left-=333*this.scaleVal;
		if(left<0)left=0;
		obj.scrollLeft=left;
		if(this.handler.config.gameSettings.language.rtl){
			obj.scrollLeft=w-left-656*this.scaleVal;
		}else
			obj.scrollLeft=left;
		if(this.handler.sentenceAudio){
			obj=document.getElementById('replayButtonContainer');
			if(obj)obj.style.display='block';
		}else{
			obj=document.getElementById('replayButtonContainer');
			if(obj)obj.style.display='none';
		}
	}
	
	this.raceReport=raceReport;function raceReport(set){
		if(set){
		}else{
			console.log('updating interface');
			console.log(this.handler.cars);
			this.handler.computePoints();
			var html='',i;
			html+='<div class="emptyBackground" style="background-image:url('+this.handler.assets.Data.Images.emptyBG.src+');height:'+(640*this.scaleVal)+'px;background-size:cover;">';
			html+='<div id="waitingText" style="position:absolute;color:#eee;text-shadow: '+(3*this.scaleVal)+'px '+(2*this.scaleVal)+'px #000;margin-top:0px;margin-left:0px;font:'+(48*this.scaleVal)+'px airstrike;width:'+(910*this.scaleVal)+'px;height:'+(54*this.scaleVal)+'px;background-image:url(\''+this.handler.assets.Data.Images.ActionBar.src+'\');background-size:100% 100%;padding-top:'+(10*this.scaleVal)+'px;padding-left:'+(50*this.scaleVal)+'px;" align="left">'+this.handler.config.menuTexts.raceResults+'</div>';
			setCookie('typingRaceGameScore','',0);
			if(GSP && GSP.isInitiated() && !GSP.isPlayerLogin() && !this.handler.cars[this.handler.player.carID].crash){
				html+='<div style="position:absolute;margin-left:'+(30*this.scaleVal)+'px;margin-top:'+(80*this.scaleVal)+'px;border:0px;font:'+(28*this.scaleVal)+'px airstrike;color:#000;" id="teaserText">'+this.handler.config.menuTexts.teaser1+' ';
				html+='<a href="javascript:game.UI.loginNow();">'+this.handler.config.menuTexts.teaser2+'</a>';
				html+='</div>';
			}
			html+='<div style="position:absolute;margin-top:'+(100*this.scaleVal)+'px;margin-left:0px;border:0px;width:'+(960*this.scaleVal)+'px;">';
			this.cars=new Array();
			for(i=0;i<this.handler.cars.length;i++)this.cars[i]=this.handler.cars[i];
			this.cars.sort(function(a,b){
				if(a.crash && b.crash)return(b.position-a.position);
				if(a.crash){
					if(!b.finished)return(-1);
					return(1);
				}
				if(b.crash){
					if(!a.finished)return(1);
					return(-1);
				}
				if(a.finished && !b.finished)return(-1);
				if(!a.finished && b.finished)return(1);
				if(!a.finished && !b.finished)return(b.position-a.position);
				return(a.finishTime-b.finishTime);
			});
			for(i=0;i<this.cars.length;i++){
				if(!this.cars[i].finished && !this.cars[i].crash)break;//remove this to show cars still in race
				html+='<div style="float:left;padding:'+(10*this.scaleVal)+'px;">'+this.getEndCarReport(i,i+1)+'</div>';
			}
			html+='<div style="clear:both"></div></div>';
			html+='<div style="position:absolute;margin-top:'+(330*this.scaleVal)+'px;">';
			html+=this.getPlayerCarReport();
			html+='</div>';
			html+='<div style="position:absolute;margin-top:'+(560*this.scaleVal)+'px;">';
				html+='<div style="float:left;margin-left:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.MainMenu,'64',180,55,24,0,0,'mainMenuButtPress')+'</div>';
				html+='<div style="float:left;margin-left:'+(180*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Garage,'64',180,55,24,0,0,'garrageButtonPress')+'</div>';
				html+='<div style="float:left;margin-left:'+(180*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.RaceAgain,'64',180,55,24,0,0,'raceAgainButtPress')+'</div>';
			html+='</div>';
			html+='</div>';
			this.mainDiv.innerHTML=html;
			this.mainDiv.style.backgroundImage='';
			var car=this.handler.cars[this.handler.player.carID];
		}
	}
	
	this.mainMenuButtPress=mainMenuButtPress;function mainMenuButtPress(){
		this.handler.gameOver('main menu');
//		this.handler.status='main menu';
	}
	
	this.raceAgainButtPress=raceAgainButtPress;function raceAgainButtPress(){
		this.handler.gameOver('startNewGame');
//		this.handler.startGame();
	}
	
	this.loginNow=loginNow;function loginNow(){
		if(!GSP)return;
		if(!GSP.isInitiated())return;
		setCookie('typingRaceSkipAdd','skip',10000);
		var points=game.getPoints();
		var saveData={
			"score" : game.getScore(),
			"points": points,
			"payload":'{"position":"'+game.getPosition()+'","time":"'+game.getRaceTime()+'","errors":"'+game.getErrors()+'"}'
		};
		var cvalue=JSON.stringify(saveData);
		console.log('saving current score: '+cvalue);
		setCookie('typingRaceGameScore',cvalue,30000);
		this.handler.gameOver('login screen 2');
	}
	
	this.getEndCarReport=getEndCarReport;function getEndCarReport(index,place){
		var html=''
		var car=this.cars[index];
		var img=this.handler.assets.Data.Images['carImg_'+car.car.carType+'_0'];
		var fontSize=18*this.scaleVal,fontFamily='Arial';
		this.measuringCtx.font=fontSize+"px "+fontFamily;
		var w=this.measuringCtx.measureText(car.name).width;
		while(w>140*this.scaleVal && fontSize>0){
			fontSize-=0.1;
			this.measuringCtx.font=fontSize+"px "+fontFamily;
			w=this.measuringCtx.measureText(car.name).width;
		}
		html+='<div style="width:'+(168*this.scaleVal)+'px;padding-top:'+(80-img.height/2.2)+'px;" align="center">';
		html+='<img src="'+img.src+'" width="'+(img.width*this.scaleVal/2.2)+'" height="'+(img.height*this.scaleVal/2.2)+'" />';
		
		if(car.crash)
			html+='<div style="font:'+(28*this.scaleVal)+'px airstrike;padding-top:'+(20*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Disqualified+'</div>';
		else if(!car.crash && !car.finished)
			html+='<div style="font:'+(28*this.scaleVal)+'px airstrike;padding-top:'+(20*this.scaleVal)+'px;">'+'in race'+'</div>';
		else
			html+='<div style="font:'+(28*this.scaleVal)+'px airstrike;padding-top:'+(20*this.scaleVal)+'px;">'+place+((place==1)?this.handler.config.menuTexts.st:((place==2)?this.handler.config.menuTexts.nd:((place==3)?this.handler.config.menuTexts.rd:this.handler.config.menuTexts.th)))+' '+this.handler.config.menuTexts.PLACE+'</div>';
		html+='<div style="font:'+(fontSize)+'px Arial;padding-top:'+(5*this.scaleVal)+'px;height:'+(30*this.scaleVal)+'px;">'+car.name+'</div>';
		if(car.crash)
			html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(0*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Crashed+'</b></div>';
		else
			html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(0*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Speed+' '+Math.round(car.WPM)+' '+this.handler.config.menuTexts.WPM+'</b></div>';
		var minutes=0;var seconds=0;
		var time;
		if(car.crash)time=car.crashTime;else time=car.finishTime;
		time-=this.handler.raceTime;
		if(time<0)time=0;
		minutes=Math.floor(time/60000);
		time-=minutes*60000;
		seconds=Math.floor(time/1000);
		if(minutes<=9)minutes='0'+minutes;
		if(seconds<=9)seconds='0'+seconds;
		var points=this.handler.getPoints(car);
		var coins=Math.round(points/2);
		html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(2*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Time+' '+minutes+':'+seconds+'</b></div>';
		html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(2*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.points+' '+points+'</b></div>';
		if(car.type=='MP' || (GSP && car.type=='PC'))
			html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(2*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Coins+':&nbsp;&nbsp;&nbsp;'+coins+'</b></div>';
		html+='</div>';
		return html;
	}
	
	this.getPlayerCarReport=getPlayerCarReport;function getPlayerCarReport(){
		var html='';
		var car=this.cars[this.handler.player.carID];
		var i=0;
		for(i=0;i<this.handler.cars.length;i++)if(this.handler.cars[i].type=='PC')break;
		if(i<this.handler.cars.length)car=this.handler.cars[i];
		var img=this.handler.assets.Data.Images['carImg_'+car.car.carType+'_0'];

		var time;
		if(car.crash)time=car.crashTime;else time=car.finishTime;
		time-=this.handler.raceTime;
		if(time<0)time=0;
		var minutes=Math.floor(time/60000);
		time-=minutes*60000;
		var seconds=Math.floor(time/1000);
		if(minutes<=9)minutes='0'+minutes;
		if(seconds<=9)seconds='0'+seconds;
		var scoreText=(car.crash?('<span style="color:#f00">'+this.handler.config.menuTexts.Disqualified+'</span>'):(Math.round(car.WPM)+' '+this.handler.config.menuTexts.WPM));

		if(car.WPM>car.highScore)car.highScore=car.WPM;
		
		html+='<div align="center" style="padding-left:'+(30*this.scaleVal)+'px">';
		html+='<div style="height:'+(100*this.scaleVal)+'px;" align="left"><img src="'+img.src+'" width="'+(img.width*this.scaleVal/2)+'" height="'+(img.height*this.scaleVal/2)+'" style="padding-top:'+((100-img.height/2)*this.scaleVal)+'px;" /></div>';
		html+='<table style="border:solid 5px #5d5d5f;width:'+(900*this.scaleVal)+'px;font:'+(20*this.scaleVal)+'px Arial;" cellspacing="0" cellpadding="'+(2*this.scaleVal)+'">';
		html+='<tr><td colspan="2" style="background-color:#dbdbdb;font:'+(28*this.scaleVal)+'px airstrike;" align="center">'+this.handler.config.menuTexts.Statistics+'</td></tr>';
		if(!GSP || !GSP.isPlayerLogin())car.totalPoints=3;
		var points=this.handler.getPoints(car);
		var coins=Math.round(points/2);
		coins=this.handler.player.coins;
		html+='<tr style="background-color:#969799;"><td style="border-right:solid 2px #717274;padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Score+' : '+scoreText+'</td><td style="padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Rating+' : '+car.totalPoints+'</td></tr>';
//		if(GSP.isPlayerLogin())
		if(!car.crash)
			html+='<tr style="background-color:#b3b3b5;"><td style="border-right:solid 2px #868688;padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Time+' '+minutes+':'+seconds+'</td><td style="padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.SuccessRate+': '+Math.round(car.position/(car.position+car.ERR)*100)+'%'+'</td></tr>';
		if(GSP && GSP.isPlayerLogin())
			html+='<tr style="background-color:#'+(car.crash?'b3b3b5':'969799')+';"><td style="padding-left:'+(10*this.scaleVal)+'px;border-right:solid 2px #'+(car.crash?'868688':'717274')+';">'+this.handler.config.menuTexts.MyBestScore+' : '+Math.round(car.highScore)+' '+this.handler.config.menuTexts.WPM+'</td><td style="padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Coins+' : '+coins+'</td></tr>';
		html+='</table></div>';
		return(html);
	}
	
	this.getGarrage=getGarrage;function getGarrage(set){
		if(this.handler.loadingStage<1)return;
		if(!this.handler.player){this.loginScreen1(set);return;}
		if(set){
			if(this.slideDoor && this.slideDoor>145){
				var obj;
				this.slideDoor-=10;
				if(this.slideDoor<145)slideDoor=145;
				if(this.slideDoor==145){
					obj=document.getElementById('garrageArrowL');
					if(obj)obj.style.zIndex=5;
					obj=document.getElementById('garrageArrowR');
					if(obj)obj.style.zIndex=5;
					obj=document.getElementById('carButtons');
					if(obj)obj.style.zIndex=5;
				}
				obj=document.getElementById('garrageDoor');
				if(obj)
					obj.style.backgroundPosition='0px '+((this.slideDoor-555)*this.scaleVal)+'px';
			}
			this.garrageChange();
		}else{
			this.handler.gameType=false;
			this.slideDoor=0;
			this.GcarPos=0,GcarDir=0;
			var html=''
			html+='<div style="position:absolute;z-index:1;margin-left:'+(305*this.scaleVal)+'px;margin-top:'+(0*this.scaleVal)+'px;width:'+(655*this.scaleVal)+'px;height:'+(565*this.scaleVal)+'px;overflow:hidden;" align="center"><div id="garrageCarContainer"></div></div>';
			html+='<div id="garrageCarCostContainer" style="margin-left:'+(305*this.scaleVal)+'px;margin-top:'+(390*this.scaleVal)+'px;width:'+(655*this.scaleVal)+'px;font:'+(32*this.scaleVal)+'px airstrike;" align="center"></div>';
			html+='<div style="position:absolute;z-index:2;margin-left:'+(325*this.scaleVal)+'px;margin-top:'+(215*this.scaleVal)+'px;width:'+(608*this.scaleVal)+'px;height:'+(365*this.scaleVal)+'px;background-size:100%;background-image:url('+this.handler.assets.Data.Images.garrageHolders.src+');"></div>';
			html+='<div id="garrageDoor" style="z-index:3;margin-left:'+(305*this.scaleVal)+'px;margin-top:'+(85*this.scaleVal)+'px;width:'+(655*this.scaleVal)+'px;height:'+(555*this.scaleVal)+'px;background-image:url('+this.handler.assets.Data.Images.garrageClose.src+');"></div>';
			html+='<div id="garrageArrowL" class="garrageArrow" onclick="game.UI.garrageChange(-1);" style="z-index:2;width:'+(55*this.scaleVal)+'px;height:'+(45*this.scaleVal)+'px;margin-top:'+(500*this.scaleVal)+'px;margin-left:'+(355*this.scaleVal)+'px;"></div>';
			html+='<div id="garrageArrowR" class="garrageArrow flippedImg" onclick="game.UI.garrageChange(1);" style="z-index:2;width:'+(55*this.scaleVal)+'px;height:'+(45*this.scaleVal)+'px;margin-top:'+(500*this.scaleVal)+'px;margin-left:'+(835*this.scaleVal)+'px;"></div>';
			html+='<div style="position:absolute;margin-left:'+(37*this.scaleVal)+'px;margin-top:'+(17*this.scaleVal)+'px;">';//50
			
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;" id="carUpgradeButt">'+this.getTextButtonCode(this.handler.config.menuTexts.CarUpgrade,'65',227,66,32,0,0,'carUpgradeButtonPress')+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;display:none;" id="carUpgradePanel">'+this.getTextButtonCode(this.handler.config.menuTexts.CarUpgrade,'65On',227,66,32,0,0,false)+'</div>';
			if(GSP.isPlayerLogin()){
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.GlobalRank,'65',227,66,32,0,0,'globalRankButtonPress')+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.RaceHistory,'65',227,66,32,0,0,'raceHistoryButtonPress')+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Share,'65',227,66,32,0,0,'shareButtonPress','sharing-button')+'</div>';
			}else{
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.GlobalRank,'65off',227,66,32,0,0)+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.RaceHistory,'65off',227,66,32,0,0)+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Share,'65off',227,66,32,0,0)+'</div>';
			}
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Back,'65',227,66,32,0,0,'mainMenuButtPress')+'</div>';
			html+='</div>';
			
			
			this.carType=this.handler.player.carType;
			if(GSP.isPlayerLogin()){
				html+='<div style="position:absolute;z-index:40;margin-left:'+(490*this.scaleVal)+'px;margin-top:'+(25*this.scaleVal)+'px;font:'+(32*this.scaleVal)+'px airstrike;color:#000;">'+this.handler.config.menuTexts.YouHave+'&nbsp;<span style="color:#f15a29;" id="coinsContainer">'+this.handler.player.coins+'</span>&nbsp;'+this.handler.config.menuTexts.Coins+'</div>';
				html+='<div style="position:absolute;z-index:2;margin-left:'+(560*this.scaleVal)+'px;margin-top:'+(550*this.scaleVal)+'px;font:'+(32*this.scaleVal)+'px airstrike;color:#000;" id="carButtons">';
				html+='<div id="useCarButt" style="display:none;">'+this.getTextButtonCode(this.handler.config.menuTexts.Use,'64',140,45,24,0,0,'useCarButtonPress')+'</div>';
				html+='<div id="buyCarButt" style="display:none;">'+this.getTextButtonCode(this.handler.config.menuTexts.Buy,'64',140,45,24,0,0,'buyCarButtonPress')+'</div>';
				html+='<div id="buyDisabledCarButt" style="display:none;">'+this.getTextButtonCode(this.handler.config.menuTexts.Buy,'64disabled',140,45,24,0,0)+'</div>';
				html+='</div>';
			}else{
				html+='<div style="position:absolute;z-index:40;margin-left:'+(785*this.scaleVal)+'px;margin-top:'+(13*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Login,'65',149,45,24,0,0,'loginButtonPress')+'</div>';
			}

			
			html+='<div style="position:absolute;margin-top:0px;margin-left:0px;z-index:100;"><span style="font:'+40*this.scaleVal+'px airstrike;"><div id="loadingTextContainer" style="width:'+(960*this.scaleVal)+'px;line-height:'+(640*this.scaleVal)+'px;" align="center">Loading...</div></span></div>';
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.garrageBG.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			this.mainDiv.innerHTML=html;
//			addthis.button('#sharing-button', {}, {url: 'topic_link', title: 'topic_title'});
			addthis.button('#sharing-button', {ui_click:false,ui_hover_direction:1,ui_delay:500,ui_offset_left:(250*this.scaleVal)});
//			addthis.button('#sharing-button', {ui_click:true,ui_hover_direction:1,ui_delay:0});
			this.Gcar=new Ccar(this.handler,this.handler.player.carType,0);
			this.Gcar.DrawGarrage();
		}
	}
	
	this.useCarButtonPress=useCarButtonPress;function useCarButtonPress(){
		var obj=document.getElementById('loadingTextContainer');if(obj)obj.style.display='block';
		this.handler.player.carType=this.carType;
		if(GSP && GSP.isPlayerLogin())savePlayerData();
		else if(obj)obj.style.display='none';
	}

	this.buyCarButtonPress=buyCarButtonPress;function buyCarButtonPress(){
		var obj=document.getElementById('loadingTextContainer');if(obj)obj.style.display='block';
		var cost=this.handler.config.gameSettings.cars[this.carType].cost;
		if(this.handler.player.coins>=cost){
			this.handler.player.coins-=cost;
			this.handler.player.ownedCars[this.carType]=true;
			this.handler.player.carType=this.carType;
			if(GSP && GSP.isPlayerLogin())savePlayerData();
			else if(obj)obj.style.display='none';
		}
	}

	this.garrageChange=garrageChange;function garrageChange(direction){
		var Max=30;
		if(direction){
			this.GcarDir=direction;
		}else{
			if(!this.GcarDir)return;
			this.GcarPos+=this.GcarDir;
			if(this.GcarPos==0)this.GcarDir=0;
			if(this.GcarPos>Max){
				this.GcarPos=-Max;
				this.carType++;
				if(this.carType>=this.handler.config.gameSettings.cars.length)this.carType=0;
				this.Gcar.carType=this.carType;
			}else if(this.GcarPos<-Max){
				this.GcarPos=Max;
				this.carType--;
				if(this.carType<0)this.carType=this.handler.config.gameSettings.cars.length-1;
				this.Gcar.carType=this.carType;
			}
			this.Gcar.DrawGarrage(this.GcarPos);
		}
	}
	
	this.carUpgradeButtonPress=carUpgradeButtonPress;function carUpgradeButtonPress(){
		var obj=document.getElementById('carUpgradeButt');
		if(obj)obj.style.display='none';
		obj=document.getElementById('carUpgradePanel');
		if(obj)obj.style.display='block';
		this.slideDoor=555;
	}
	
	this.globalRankButtonPress=globalRankButtonPress;function globalRankButtonPress(){
		var obj=document.getElementById('loadingTextContainer');if(obj)obj.style.display='block';
		//this.handler.status='waiting';
		if(!GSP)return;
		GSP.getPlayerBestScores({},function(status, data){
			game.player.points=parseInt(data.points);
			game.player.rank=parseInt(data.rank);
			game.player.highScore=parseInt(data.score);
			game.status='GlobalRank';
			game.UI.status=false;
		});
	}
	
	this.raceHistoryButtonPress=raceHistoryButtonPress;function raceHistoryButtonPress(){
		var obj=document.getElementById('loadingTextContainer');if(obj)obj.style.display='block';
		//this.handler.status='waiting';
		if(!GSP)return;
		GSP.getPlayerResults({"sort_order":"DATE","sort_direction":"DESC"},function(status, data){
			game.status='RaceHistory';
			game.UI.raceHistory=data;
			game.UI.status=false;
		});
	}
	
	this.shareButtonPress=shareButtonPress;function shareButtonPress(){
	}
	
	this.getHighScores=getHighScores;function getHighScores(period,sort_order){
		var obj=document.getElementById('loadingTextContainer');if(obj)obj.style.display='block';
//		this.handler.status='waiting';
		if(!GSP)return;
		GSP.getHighscores({
			'period':period,
			'sort_order':sort_order
		},function(status,data){
			game.UI.highScoreData={
				'data':data,
				'period':period,
				'sort_order':sort_order
			}
			game.status='HighScores';
			game.UI.status=false;
		});
	}
	
	this.highScores=highScores;function highScores(set){
		if(set){
		}else{
			//getTextButtonCode(text,classN,width,height,font_size,textX,textY,callFunc)
			//this.getTextButtonCode(this.handler.config.menuTexts.Guest,'52',226,52,32,0,0,'guestButtonPress')
			var html='',clasB,func,zindex;
			html+='<div id="waitingText" style="position:absolute;color:#eee;text-shadow: '+(3*this.scaleVal)+'px '+(2*this.scaleVal)+'px #000;margin-top:0px;margin-left:0px;font:'+(48*this.scaleVal)+'px airstrike;width:'+(910*this.scaleVal)+'px;height:'+(54*this.scaleVal)+'px;background-image:url(\''+this.handler.assets.Data.Images.ActionBar.src+'\');background-size:100% 100%;padding-top:'+(10*this.scaleVal)+'px;padding-left:'+(50*this.scaleVal)+'px;" align="left">'+this.handler.config.menuTexts.highScore+'</div>';
			html+='<div style="position:absolute;margin-top:'+(90*this.scaleVal)+'px;margin-left:'+(35*this.scaleVal)+'px;">';
			clasB='64R';func='highScoresTodayButtonPress';if(this.highScoreData.period=='DAILY'){clasB='64ROn';func=false;}
			html+='<div style="float:left">'+this.getTextButtonCode(this.handler.config.menuTexts.Today,clasB,140,45,25,0,0,func)+'</div>';
			clasB='64R';func='highScoresWeeklyButtonPress';if(this.highScoreData.period=='WEEKLY'){clasB='64ROn';func=false;}
			html+='<div style="float:left;padding-left:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Weekly,clasB,140,45,25,0,0,func)+'</div>';
			clasB='64R';func='highScoresMonthlyButtonPress';if(this.highScoreData.period=='MONTHLY'){clasB='64ROn';func=false;}
			html+='<div style="float:left;padding-left:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Monthly,clasB,140,45,25,0,0,func)+'</div>';
			clasB='64R';func='highScoresAllTimeButtonPress';if(this.highScoreData.period=='ALL_TIME'){clasB='64ROn';func=false;}
			html+='<div style="float:left;padding-left:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.AllTime,clasB,140,45,25,0,0,func)+'</div>';
			html+='<div style="clear:both"></div>';
			html+='</div>';
			
			clasB='tab';func='highScoresFastestButtonPress';zindex=12;if(this.highScoreData.sort_order=='SCORE'){clasB='tabOn';func=false;zindex=15;}
			html+='<div style="position:absolute;margin-top:'+(170*this.scaleVal)+'px;margin-left:'+(34*this.scaleVal)+'px;z-index:'+zindex+';">'+this.getTextButtonCode(this.handler.config.menuTexts.Fastest,clasB,200,45,16,-20,0,func)+'</div>';
			clasB='tab';func='highScoresMostParticipatedtButtonPress';zindex=11;if(this.highScoreData.sort_order=='GAME_PLAYED'){clasB='tabOn';func=false;zindex=15;}
			html+='<div style="position:absolute;margin-top:'+(170*this.scaleVal)+'px;margin-left:'+(204*this.scaleVal)+'px;z-index:'+zindex+';">'+this.getTextButtonCode(this.handler.config.menuTexts.MostParticipated,clasB,200,45,16,-20,0,func)+'</div>';
			clasB='tab';func='highScoresHighestRatingButtonPress';zindex=10;if(this.highScoreData.sort_order=='POINTS'){clasB='tabOn';func=false;zindex=15;}
			html+='<div style="position:absolute;margin-top:'+(170*this.scaleVal)+'px;margin-left:'+(374*this.scaleVal)+'px;z-index:'+zindex+';">'+this.getTextButtonCode(this.handler.config.menuTexts.HighestRating,clasB,200,45,16,-20,0,func)+'</div>';
			
			html+='<div style="position:absolute;margin-top:'+(215*this.scaleVal)+'px;margin-left:'+(35*this.scaleVal)+'px;">';
			html+='<table border="0" cellspacing="0" cellpadding="0" style="border:solid '+(3*this.scaleVal)+'px #1f1f29;width:'+(894*this.scaleVal)+'px;font:'+(18*this.scaleVal)+'px Arial;">';
			html+='<tr style="background-image:url(\''+this.handler.assets.Data.Images.highScoresHeading.src+'\');background-size:100% 100%;"><td align="center" height="'+(30*this.scaleVal)+'"><b>'+this.handler.config.menuTexts.RacerName+'</b></td>';
			html+='<td align="center"><b>'+this.handler.config.menuTexts.RacesFinished+'</b></td><td align="center"><b>'+this.handler.config.menuTexts.Rating+'</b></td><td align="center"><b>'+this.handler.config.menuTexts.WPM+'</b></td></tr>';
			var data=this.highScoreData.data;
			for(i=data.length;i<12;i++)data[i]={
				"player":{
					"name":"&nbsp;",
					"imageUrl":""
				},
				"score":"",
				"points":"",
				"gamePlayed":"",
				"rank":""
			}
			for(i=0;i<12;i++){
				bgcolor='99979a';if(i%2)bgcolor='78787a';
				html+='<tr style="background-color:#'+bgcolor+'">';
				bgcolor='848484';if(i%2)bgcolor='5d5d5f';
				html+='<td align="center" height:"'+(30*this.scaleVal)+'">';
				if(data[i].player.imageUrl)html+='<div style="float:left;"><img src="'+data[i].player.imageUrl+'" width="'+(24*this.scaleVal)+'" height="'+(24*this.scaleVal)+'" /></div><div style="float:left;width:'+(6*this.scaleVal)+'px;">&nbsp;';else html+='<div style="float:left;width:'+(30*this.scaleVal)+'px;">';
				html+='</div><div style="float:left">'+data[i].player.name+'</div></td>';
				html+='<td style="background-color:#'+bgcolor+'" align="center">'+data[i].gamePlayed+'</td>';
				html+='<td align="center">'+data[i].points+'</td>';
				html+='<td style="background-color:#'+bgcolor+'" align="center">'+(data[i].score?Math.round(data[i].score):'&nbsp;')+'</td>';
				html+='</tr align="center">';
				
			}
			html+='</table></div>';
			
			html+='<div style="position:absolute;margin-left:'+(740*this.scaleVal)+'px;margin-top:'+(555*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Back,'64',170,45,25,0,0,'mainMenuButtPress')+'</div>';
			
			html+='<div style="position:absolute;margin-top:0px;margin-left:0px;z-index:100;"><span style="font:'+40*this.scaleVal+'px airstrike;"><div id="loadingTextContainer" style="width:'+(960*this.scaleVal)+'px;line-height:'+(640*this.scaleVal)+'px;" align="center">Loading...</div></span></div>';
			
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.emptyBG.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			this.mainDiv.innerHTML=html;
		}
	}
	
	this.highScoresTodayButtonPress=highScoresTodayButtonPress;function highScoresTodayButtonPress(){
		this.getHighScores('DAILY',this.highScoreData.sort_order);
	}
	
	this.highScoresWeeklyButtonPress=highScoresWeeklyButtonPress;function highScoresWeeklyButtonPress(){
		this.getHighScores('WEEKLY',this.highScoreData.sort_order);
	}

	this.highScoresMonthlyButtonPress=highScoresMonthlyButtonPress;function highScoresMonthlyButtonPress(){
		this.getHighScores('MONTHLY',this.highScoreData.sort_order);
	}

	this.highScoresAllTimeButtonPress=highScoresAllTimeButtonPress;function highScoresAllTimeButtonPress(){
		this.getHighScores('ALL_TIME',this.highScoreData.sort_order);
	}
	
	this.highScoresFastestButtonPress=highScoresFastestButtonPress;function highScoresFastestButtonPress(){
		this.getHighScores(this.highScoreData.period,'SCORE');
	}

	this.highScoresMostParticipatedtButtonPress=highScoresMostParticipatedtButtonPress;function highScoresMostParticipatedtButtonPress(){
		this.getHighScores(this.highScoreData.period,'GAME_PLAYED');
	}

	this.highScoresHighestRatingButtonPress=highScoresHighestRatingButtonPress;function highScoresHighestRatingButtonPress(){
		this.getHighScores(this.highScoreData.period,'POINTS');
	}
	
	this.getGlobalRank=getGlobalRank;function getGlobalRank(set){
		if(set){
		}else{
			html='';
			var car={'WPM':game.player.highScore,'highScore':game.player.highScore};
			var level=this.handler.calculateLevel(car);
			html+='<div id="waitingText" style="position:absolute;color:#eee;text-shadow: '+(3*this.scaleVal)+'px '+(2*this.scaleVal)+'px #000;margin-top:0px;margin-left:0px;font:'+(48*this.scaleVal)+'px airstrike;width:'+(910*this.scaleVal)+'px;height:'+(54*this.scaleVal)+'px;background-image:url(\''+this.handler.assets.Data.Images.ActionBar.src+'\');background-size:100% 100%;padding-top:'+(10*this.scaleVal)+'px;padding-left:'+(50*this.scaleVal)+'px;" align="left">'+this.handler.config.menuTexts.Achievements+'</div>';
			html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(0*this.scaleVal)+'px;margin-top:'+(120*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;color:#020202;" align="center">'+this.handler.config.menuTexts.TypingLevel+'&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:#fefefe;">'+level.name+'</span></div>';
			html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(0*this.scaleVal)+'px;margin-top:'+(155*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;color:#020202;" align="center">'+this.handler.config.menuTexts.FastestRace+'&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:#fefefe;">'+game.player.highScore+'&nbsp;'+this.handler.config.menuTexts.WPM+'</span></div>';
			html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(0*this.scaleVal)+'px;margin-top:'+(190*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;color:#020202;" align="center">'+this.handler.config.menuTexts.GlobalRank+'&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:#fefefe;">'+this.handler.config.menuTexts.top+'&nbsp;'+game.player.rank+'%</span></div>';
			html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(0*this.scaleVal)+'px;margin-top:'+(225*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;color:#020202;" align="center">'+this.handler.config.menuTexts.RatingPoints+'&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:#fefefe;">'+game.player.points+'</span></div>';
			html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(0*this.scaleVal)+'px;margin-top:'+(260*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;color:#020202;" align="center">'+this.handler.config.menuTexts.Coins+'&nbsp;&nbsp;&nbsp;&nbsp;<span style="color:#fefefe;">'+game.player.coins+'</span></div>';
			
			var str=this.handler.config.menuTexts.yourLevel;
			str=str.replace('$level;',level.level);
			html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(0*this.scaleVal)+'px;margin-top:'+(330*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;color:#020202;" align="center">'+str+'</div>';
			
			var carImg=game.assets.Data.Images['carImg_'+this.handler.player.carType+'_'+index];
			if(carImg){
				var w=carImg.width*1.1,h=carImg.height*1.1;
				html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(100*this.scaleVal)+'px;margin-top:'+(435*this.scaleVal)+'px;width:'+(w*this.scaleVal)+'px;height:'+(h*this.scaleVal)+'px;background-size:100% 100%;background-image:url('+carImg.src+');" align="center">&nbsp;</div>';
			}
			
			html+='<div style="position:absolute;margin-left:'+(740*this.scaleVal)+'px;margin-top:'+(555*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Back,'64',170,45,25,0,0,'garrageButtonPress')+'</div>';
			
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.emptyBG.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			this.mainDiv.innerHTML=html;
		}
	}
	
	this.getRaceHistory=getRaceHistory;function getRaceHistory(set){
		if(set){
		}else{
			html='';
			html+='<div id="waitingText" style="position:absolute;color:#eee;text-shadow: '+(3*this.scaleVal)+'px '+(2*this.scaleVal)+'px #000;margin-top:0px;margin-left:0px;font:'+(48*this.scaleVal)+'px airstrike;width:'+(910*this.scaleVal)+'px;height:'+(54*this.scaleVal)+'px;background-image:url(\''+this.handler.assets.Data.Images.ActionBar.src+'\');background-size:100% 100%;padding-top:'+(10*this.scaleVal)+'px;padding-left:'+(50*this.scaleVal)+'px;" align="left">'+this.handler.config.menuTexts.RaceHistory+'</div>';
			
			html+='<div style="position:absolute;margin-top:'+(145*this.scaleVal)+'px;margin-left:'+(35*this.scaleVal)+'px;">';
			html+='<table border="0" cellspacing="0" cellpadding="0" style="border:solid '+(3*this.scaleVal)+'px #1f1f29;width:'+(894*this.scaleVal)+'px;font:'+(18*this.scaleVal)+'px Arial;">';
			html+='<tr style="background-image:url(\''+this.handler.assets.Data.Images.highScoresHeading.src+'\');background-size:100% 100%;"><td align="center" height="'+(30*this.scaleVal)+'"><b>'+this.handler.config.menuTexts.date+'</b></td>';
			html+='<td align="center"><b>'+this.handler.config.menuTexts.position+'</b></td><td align="center"><b>'+this.handler.config.menuTexts.WPM+'</b></td>';
			html+='<td align="center"><b>'+this.handler.config.menuTexts.time+'</b></td><td align="center"><b>'+this.handler.config.menuTexts.errors+'</b></td><td align="center"><b>'+this.handler.config.menuTexts.points+'</b></td></tr>';
			var data=this.raceHistory;
			for(i=data.length;i<15;i++)data[i]={
				'date':false,
				'points':' ',
				'score':' ',
				'customData':{
					'position':' ',
					'time':' ',
					'errors':' '
				}
			};
			var date;
			var dateV=new Date;
			for(i=0;i<15;i++){
				if(isJsonString(data[i].customData))data[i].customData=JSON.parse(data[i].customData);
				else data[i].customData={'position':' ','time':' ','errors':' '};
//				data[i].customData=JSON.parse(data[i].customData);
				bgcolor='99979a';if(i%2)bgcolor='78787a';
				html+='<tr style="background-color:#'+bgcolor+'">';
				bgcolor='848484';if(i%2)bgcolor='5d5d5f';
				date=data[i].date+" ";date=date.split(" ");date=date[0];
				if(data[i].date && data[i].date!='false'){date=Date.parse(date);dateV.setTime(date);date=dateV.toLocaleDateString();}else date='&nbsp;';
				html+='<td align="center" height:"'+(30*this.scaleVal)+'">'+date+'</td>';
				html+='<td style="background-color:#'+bgcolor+'" align="center">'+data[i].customData.position+'</td>';
				html+='<td align="center">'+data[i].score+'</td>';
				html+='<td style="background-color:#'+bgcolor+'" align="center">'+data[i].customData.time+'</td>';
				html+='<td align="center">'+data[i].customData.errors+'</td>';
				html+='<td style="background-color:#'+bgcolor+'" align="center">'+data[i].points+'</td>';
				html+='</tr align="center">';
				
			}
			html+='</table></div>';
			
			var carImg=game.assets.Data.Images['carImg_'+this.handler.player.carType+'_'+index];
			if(carImg){
				var w=carImg.width*0.3,h=carImg.height*0.3;
				html+='<div style="position:absolute;font:'+(30*this.scaleVal)+'px airstrike;margin-left:'+(50*this.scaleVal)+'px;margin-top:'+((135-h)*this.scaleVal)+'px;width:'+(w*this.scaleVal)+'px;height:'+(h*this.scaleVal)+'px;background-size:100% 100%;background-image:url('+carImg.src+');" align="center">&nbsp;</div>';
			}
			
			html+='<div style="position:absolute;margin-left:'+(740*this.scaleVal)+'px;margin-top:'+(555*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Back,'64',170,45,25,0,0,'garrageButtonPress')+'</div>';
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.emptyBG.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			this.mainDiv.innerHTML=html;
			this.raceHistory=null;
		}
	}


	this.Load();
}

	function drawRotPic(image,X,Y,zoom,angle,Px,Py,ctx,scale){
		if(!ctx)return;
		ctx.save();
		ctx.translate((X+Px)*scale,(Y+Py)*scale);
		ctx.rotate(angle);
		ctx.drawImage(image,-Px*scale,-Py*scale,image.width*scale*zoom,image.height*scale*zoom);
		ctx.restore();
	}
	function drawPic(image,X,Y,zoom,ctx,scale){
		if(!ctx)return;
		ctx.drawImage(image,X*scale,Y*scale,image.width*scale*zoom,image.height*scale*zoom);
	}
